<?php


namespace app\admin\controller;
use app\admin\model\ActionLog;
use app\admin\model\GoodLog;
use app\admin\model\GoodStockInfo;
use app\admin\model\ProcessOrder;
use think\App;
use think\Exception;
use think\facade\Db;
use think\facade\Validate;

//售后
class After extends Base
{
    public function __construct(App $app)
    {
        parent::__construct($app);
    }

    public function create(){
         $outCode = isset($this->post['outCode']) &&$this->post['outCode']!=''?trim($this->post['outCode']) :"";
         if($outCode==''){
             return error_show(1004,"参数outCode 不能为空");
         }
         $orderout= Db::name("order_out")->where(["outCode"=>$outCode,'is_del'=>0])->find();
         if($orderout==false){
             return error_show(1005,"未找到订单数据");
         }
         $after_num =Db::name("order_return")->where(["orderCode"=>$orderout['orderCode'],"outCode"=>$outCode])
             ->where("status","not in",[5,6,8])->sum("error_num");

        $th_num =Db::name("order_back")->where(["orderCode"=>$orderout['orderCode'],"outCode"=>$outCode,"is_del"=>0])
            ->where("status","<",4)->sum("return_num");
        if($th_num!=0 || $after_num!=0){
            return error_show(1005,"存在售后或售后退货未结束流程");
        }
        $oder= Db::name("sale")->where(["orderCode"=>$orderout['orderCode'],"is_del"=>0])->find();
        if(empty($oder)){
            return error_show(1005,"未找到订单数据");
        }
		if($oder['order_type']!=1){
			$wsm =Db::name("warehouse_info")->where(["wsm_code"=>$orderout['wsm_code']])->find();
	        if($wsm==false){
	            return error_show(1005,"未找到仓库数据");
	        }
//	        $cgder =$wsm['contactor_name'] ??'';
//	        $cgderid =$wsm['contactor'] ??0;
		}
//		else{
//			$roleArr=\think\facade\Config::get("app");
//			$kuguan = Db::name("user_role")->where(["roleid"=>$roleArr['wsm_cgder_role'],"is_del"=>0])->column("uid");
//			if(empty($kuguan)){
//				 return error_show(1005,"未找到仓库管理员数据");
//			}
//			$userinfo = Db::name("dapart_user")
//			$cgder =$wsm['contactor_name'] ??'';
//	        $cgderid =$wsm['contactor'] ??0;
//		}

        if ($oder['order_type'] == 3) {
            $goon = Db::name("good_zixun")->where(["spuCode" => $oder['good_code'], "is_del" => 0])->find();
        } else {
            $goon = Db::name('good_platform')->alias('a')->join('good b', 'b.spuCode=a.spuCode', 'left')
                ->where(['a.skuCode' => $oder['skuCode']])->field("b.creater,b.createrid,b.supplierNo")->find();
        }
        $errorCode = isset($this->post['errorCode']) &&$this->post['errorCode']!=''?trim($this->post['errorCode']) :"";
        if($outCode==''){
            return error_show(1004,"参数errorCode 不能为空");
        }
        $error =Db::name('result_info')->where(["result_code"=>$errorCode,"is_del"=>0])->find();
        if(empty($error)){
            return error_show(1005,"未找到退货原因数据");
        }
         $supplier =Db::name("supplier")->where(["code"=>$goon['supplierNo']])->find();
        if($supplier==false){
            return error_show(1005,"未找到商品供应商数据");
        }
        $remark =isset($this->post['remark']) &&$this->post['remark']!=''?trim($this->post['remark']) :"";
        $is_receive =isset($this->post['is_receive']) &&$this->post['is_receive']!==''?intval($this->post['is_receive']):"";
        if($is_receive===""){
            return error_show(1004,"参数 is_receive 不能为空");
        }
        if($is_receive==0){
            $num=$orderout['send_num'];
        }else{
            $num =isset($this->post['num']) &&$this->post['num']!=''?intval($this->post['num']) :"";
            if($num==""){
                return error_show(1004,"参数 num 不能为空或零");
            }
        }
        $thnum =Db::name("order_back")->where(["orderCode"=>$orderout['orderCode'],"outCode"=>$outCode,"is_del"=>0])
            ->where("status","=",4)->sum("return_num");
        if($num>$orderout['send_num']-$thnum){
            return error_show(1004,"可用售后数量不足");
        }
        $except_code =isset($this->post['except_code']) &&$this->post['except_code']!=''?trim($this->post['except_code']) :"";
        $img = isset($this->post['img']) &&$this->post['img']!=''?trim($this->post['img']) :"";
        $token = isset($this->post['token'])&&$this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(105,"参数token不能为空");
        }
//        $user =GetUserInfo($token);
//        if(empty($user)||$user['code']!=0){
//            return error_show(102,"申请人数据不存在");
//        }
        $rm = $this->uid;//isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $ri = $this->uname;//isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $returnCode=makeNo("RS");
        Db::startTrans();
        try{
            $in = [
                "returnCode"=>$returnCode,
                "outCode"=>$outCode,
                "orderCode"=> $oder['orderCode'],
                "good_code"=>$oder['good_code'],
                "good_name"=>$oder['good_name'],
                "customer_code"=>$oder['customer_code'],
                "apply_id"=>$rm,
                "apply_name"=>$ri,
                "cgder"=>$wsm['contactor_name'] ??'',
                "cgderid"=>$wsm['contactor']??0,
                "person"=>$supplier['person']??'',
                "person_id"=>$supplier['personid']??0,
                'total_num'=>$orderout['send_num'],
                "error_code"=>$errorCode,
                "error_num"=>$num,
                "error_img"=>$img,
                "error_msg"=>$error['result'],
                "error_remark"=>$remark,
                "is_receive"=>$is_receive,
                "remark"=>'',
                "except_code"=>$except_code,
                "order_type"=>$orderout['order_type'],
                "status"=>1,
                "is_del"=>0,
                "addtime"=>date("Y-m-d H:i:s"),
                "updatetime"=>date("Y-m-d H:i:s")
            ];
            $create = Db::name("order_return")->insert($in,true);
            $orde = ["order_code"=>$returnCode,"status"=>$in['status'],"action_remark"=>'',"action_type"=>"create"];
            ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname],$orde,'SHD',1,$orde);
            if($create>0){

                //维护台账
//                Db::name('standing_book')
//                    ->whereFindInSet('outCode', $outCode)
//                    ->update([
//                        'returnCode' => $returnCode,
//                        'updatetime' => date("Y-m-d H:i:s")
//                    ]);

                Db::execute("UPDATE `wsm_standing_book` SET `returnCode`=CONCAT(IFNULL(`returnCode`,''),',{$returnCode}'),`updatetime`='" . date('Y-m-d H:i:s') . "' WHERE FIND_IN_SET('{$outCode}',`outCode`)");

                //当状态为1(即待业务审核)时，要将待办数据推给以下角色的用户
//                $user = Db::name('user_role')
//                    ->where([
//                        ['is_del', '=', 0],
//                        ['roleid', 'in', [12, 13, 17, 28]],//12客服负责人,13项目负责人,17平台负责人,28网络负责人
//                        ['status', '=', 1],
//                    ])->column('uid');

                //筛选符合数据权限的用户
//                $temp = getUserIdsByShare('', $in['apply_id']);
//                $user = array_intersect($user, $temp);

                $process = ["order_code" => $returnCode, "order_id" => $create, "order_status" => $in['status'], "order_type" => 'SHD', "before_status" => 0,'holder_id' => $in['apply_id']];
                    ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname],$process);
                    Db::commit();
                    return app_show(0,"售后申请单新建成功",["returnCode"=>$returnCode]);
            }
            Db::rollback();
            return error_show(1005,"售后申请单新建失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1005,$e->getMessage());
        }
    }

    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']):"10";
        $where =[['a.is_del',"=",0]];
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode!=""){
            $where[]=['a.returnCode',"like", "%{$bkcode}%"];
        }
        $out = isset($this->post['outCode']) && $this->post['outCode']!="" ? trim($this->post['outCode']):"";
        if($out!=""){
            $where[]=['a.outCode',"like", "%{$out}%"];
        }
        $status = isset($this->post['status']) && $this->post['status']!=="" ? intval($this->post['status']):"";
        if($status!==""){
            $where[]=['a.status',"=", $status];
        }
        $order_type = isset($this->post['order_type']) && $this->post['order_type']!=="" ? intval($this->post['order_type']):"";
        if($order_type!==""){
            $where[]=['a.order_type',"=", $order_type];
        }
        $orderCode = isset($this->post['orderCode']) && $this->post['orderCode']!="" ? trim($this->post['orderCode']) :"";
        if($orderCode!=""){
            $where[]=['a.orderCode',"like", "%{$orderCode}%"];
        }
        $good_code = isset($this->post['good_code']) && $this->post['good_code']!="" ? trim($this->post['good_code'])
            :"";
        if($good_code!=""){
            $where[]=['a.good_code',"like", "%{$good_code}%"];
        }
        $good_name = isset($this->post['good_name']) && $this->post['good_name']!="" ? trim($this->post['good_name'])
            :"";
        if($good_name!=""){
            $where[]=['a.good_name',"like", "%{$good_name}%"];
        }
        $customer_code = isset($this->post['customer_code']) && $this->post['customer_code']!="" ? trim($this->post['customer_code'])
            :"";
        if($customer_code!=""){
            $where[]=['a.customer_code',"like", "%{$customer_code}%"];
        }
        $except_code = isset($this->post['except_code']) && $this->post['except_code']!="" ? trim($this->post['except_code']):"";
        if($except_code!=""){
            $where[]=['a.except_code',"=", $except_code];
        }
        $apply_name = isset($this->post['apply_name']) && $this->post['apply_name']!="" ? trim($this->post['apply_name'])
            :"";
        if($apply_name!=""){
            $where[]=['a.apply_name',"like", "%{$apply_name}%"];
        }
        $start =isset($this->post['start'])&&$this->post['start']!='' ? $this->post['start']:"";
        if($start!==""){
            $where[]=['a.addtime',">=", $start];
        }
        $end =isset($this->post['end'])&&$this->post['end']!='' ? $this->post['end']:"";
        if($end!==""){
            $where[]=['a.addtime',"<=", $end];
        }
        $role=$this->checkRole();
        $condition='';
        if(!empty($role['write']) && $this->uid!=""){
        	$cgdArr =\think\facade\Config::get("app");
        	$cgdids =implode(",",$cgdArr['wsm_cgder_role']);
            $condition .="a.cgderid = {$this->uid} or a.apply_id in (".implode(',',$role['write']).") or a.person_id={$this->uid} or (order_type=1 and {$this->roleid} in ($cgdids))";
        }
        $company_name = isset($this->post['company_name']) && $this->post['company_name'] !== "" ? trim($this->post['company_name']) : "";
        if ($company_name !== "") $where[] = ["a.apply_id", 'in', get_company_item_user_by_name($company_name)];

        $count=Db::name("order_return")->alias("a")->leftJoin("order_returninfo b","a.returnCode=b.returnCode")->where
        ($where)->where($condition)->count();
        $total = ceil($count/$size);
        $page = $total>=$page ? $page :$total;
        $list =Db::name("order_return")
            ->alias("a")
            ->leftJoin("order_returninfo b","a.returnCode=b.returnCode")
            ->where($where)
            ->where($condition)
            ->field("a.*,b.return_wsm,b.contactor,b.mobile,b.addr,b.addr_code,b.post_code,b.post_company,b.post_fee,b.gys_remark,u.itemid,a.orderCode")
            ->page($page,$size)
            ->leftJoin("depart_user u", "u.uid=a.apply_id AND u.is_del=0")
            ->order("addtime desc")
            ->cursor();
        $data=[];
        foreach ($list as $value){
            $customer = Db::name("customer_info")->where(["companyNo"=>$value['customer_code']])->find();
            $value['customer_name'] = isset($customer['companyName']) ?trim($customer['companyName']):'';
            $value['company_name'] = implode('/', array_column(GetPart($value['itemid']), 'name'));
            $data[]=$value;
        }
        return app_show(0,"获取成功",['list'=>$data,"count"=>$count]);
    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function  info()
    {
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode'] != "" ? trim($this->post['returnCode']) : "";
        if ($bkcode == "") {
            return error_show(1005, "参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->alias("a")->leftJoin("order_returninfo b", "a.returnCode=b.returnCode")
            ->field("a.*,b.return_wsm,b.contactor,b.mobile,b.addr,b.addr_code,b.post_code,b.post_company,b.post_fee,b.gys_remark")
            ->where(['a.returnCode' => $bkcode])->find();
        if (empty($info)) {
            return error_show(1005, "未找到售后数据");
        }
        $orderinfo = Db::name("sale")->where(["orderCode" => $info["orderCode"]])->find();
        $info['origin_price'] = $orderinfo['origin_price'];
        $info['order_type'] = $orderinfo['order_type'];
        $info['sale_price'] = $orderinfo['sale_price'];
        $info['total_price'] = sprintf("%1\$.2f", $orderinfo['sale_price'] * $info['error_num']);
        if ($orderinfo['order_type'] == 3) {
            $goon = Db::name("good_zixun")->where(["spuCode" => $orderinfo['good_code'], "is_del" => 0])->find();
        } else {
            $goon = Db::name('good_platform')->alias('a')->join('good b', 'b.spuCode=a.spuCode', 'left')
                ->where(['a.skuCode' => $orderinfo['skuCode']])->find();
        }
        if (empty($goon)) {
            return error_show(1003, "未找到商品数据");
        }
        $int = isset($goon['cat_id']) && $goon['cat_id'] != 0 ? made($goon['cat_id']) : [];
        $addcode = '';
        if ($info['addr_code'] != "") {
            list($a, $b, $c) = explode(",", $info['addr_code']);
        $addcode = json_encode(["provice_code" => $a, "city_code" => $b, "area_code" => $c]);
    }
        $info["addr_cn"]=GetAddr($addcode);
      //  $info["addr_code"]=json_decode($addcode,true);
        $out =Db::name("order_out")->where(["outCode"=>$info['outCode'],"is_del"=>0])->find();
        $info['out_num'] = isset($out['send_num'])?$out['send_num']:'';
//        $customer = Db::name("customer_info")->where(["companyNo"=>$info['customer_code']])->find();
        $wsmcode=[];
        if($info['return_wsm']!=''){
            $wsmcode = Db::name("warehouse_info")
                ->alias("a")
                ->leftJoin("supplier b","a.supplierNo=b.code")
                ->where(["a.wsm_code"=>$info['return_wsm']])
                ->field("a.name as wsm_name,b.name,b.code,a.wsm_code,a.contactor_name,a.position,a.mobile,a.addrs_code,a.addr,a.companyNo")
                ->find();
        }

        $info['wsm_code'] =isset($wsmcode['wsm_code']) ? $wsmcode['wsm_code']:"";
        $info['wsm_name'] =isset($wsmcode['wsm_name']) ? $wsmcode['wsm_name']:"";
        $info['wsm_supplier'] =isset($wsmcode['name']) ? $wsmcode['name']:"";
        $info['wsm_supplierNo'] =isset($wsmcode['code']) ? $wsmcode['code']:"";
        $customer=[];
        if(isset($orderinfo['supplierNo'])&&$orderinfo['supplierNo']!=''){
            $customer = Db::name("business")->field('id,company,companyNo')->where(["companyNo"=>$orderinfo['supplierNo']])->find();
        }

        $info['customer_name'] = isset($customer['company']) ?trim($customer['company']):'';
        $info['customer_code'] = isset($customer['companyNo']) ?trim($customer['companyNo']):'';
        $info['can']=$int;

        //仓库的联系人、职位、电话、省市区和地址
       isset($wsmcode['contactor_name'])?  $info['contactor'] =$wsmcode['contactor_name']:'';//联系人
       isset($wsmcode['mobile'])?  $info['mobile'] =$wsmcode['mobile']:'';//联系人
       isset($wsmcode['addrs_code'])?  $info['addr_code'] =$wsmcode['addrs_code']:'';//联系人
       isset($wsmcode['addr'])?  $info['addr'] =$wsmcode['addr']:'';//联系人
       isset($wsmcode['contactor_name'])?  $info['contactor'] =$wsmcode['contactor_name']:'';//联系人
//        $info['position'] = $wsmcode['position'];//职位
//        $info['mobile'] = $wsmcode['mobile'];//电话
//        $info['addrs_code'] = json_decode($wsmcode['addrs_code'], true);//省市区编码
//        $info['addr'] = $wsmcode['addr'];//地址
        $info['spuCode'] = $orderinfo['good_code'];//地址
        $info['skuCode'] = $orderinfo['skuCode'];//地址
        $info['return_tag'] = $info['return_tag']==0?"":$info['return_tag'];//地址
        $info['is_th'] = $info['is_th']==0?"":$info['is_th'];//地址

        return app_show(0,"获取成功",$info);
    }
    public function status(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $status = isset($this->post['status']) && $this->post['status']!=="" ? intval($this->post['status']) :"";
        if($status===""){
            return error_show(1005,"参数status 不能为空");
        }
        $orde= Db::name("order_out")->where(["outCode"=>$info['outCode'],"is_del"=>0])->find();
        if($orde==false){
            return error_show(1005,"未找到出库单数据");
        }
        $sale = Db::name("sale")->where(["orderCode"=> $info['orderCode']])->find();
        if($sale==false){
            return error_show(1005,"未找到销售单数据");
        }
      $remark = isset($this->post['remark'])&&$this->post['remark']!=''?trim($this->post['remark']):"";
        if($remark!=''){
            $info['remark'] =$remark;
        }
        if($status==3 && $info['is_receive']==1){
            $post =isset($this->post['is_post'])&&$this->post['is_post']!==""? intval($this->post['is_post']):"";
            if($post===""){
                return error_show(1005,"参数is_post不能为空");
            }
            $info['is_post']=$post;
            $return_tag =isset($this->post['return_tag'])&&$this->post['return_tag']!==""? intval($this->post['return_tag']):"";
            if($return_tag===""){
                return error_show(1005,"参数return_tag不能为空");
            }
            $info['return_tag']=$return_tag;
            $is_th =isset($this->post['is_th'])&&$this->post['is_th']!==""? intval($this->post['is_th']):"0";
            $info['is_th']=$is_th;
        }
//        $status = $info['order_status']==1&&$info['order_type']==1 && $status==1?4:$status;
        Db::startTrans();
        try{
            $var=$info['status'];
            $info['status']=$status;
            $info['updatetime']=date("Y-m-d H:i:s");
            $up =Db::name("order_return")->save($info);
            if($up){
                if($status==5 && $info['is_receive']==0){
                    $od_status = $orde['status'];
                    $orde['status']=4;
                    $orde['updatetime']=date("Y-m-d H:i:s");
                    $out = Db::name("order_out")->save($orde);
                    if($out==false){
                        Db::rollback();
                        return error_show(1004,"发货单更新失败");
                    }
                    $order = ["order_code"=>$orde['outCode'],"status"=>$od_status,"action_remark"=>'',"action_type"=>"edit"];
                    ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname],$order,"CKD", $orde['status'],$this->post);
                    $process=["order_code"=>$orde['outCode'],"order_id"=>$orde['id'],"order_status"=>$orde['status'],"order_type"=>"CKD","before_status"=>$od_status];
                    ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname],$process);
                    $sale['th_num'] += $info['error_num'];
                    $sale['th_fee'] += round($info['error_num']*$sale['sale_price'],2);
                    $sale['updatetime']=date("Y-m-d H:i:s");
                    $sup =Db::name("sale")->save($sale);
                    if($sup==false){
                        Db::rollback();
                        return error_show(1004,"销售单更新失败");
                    }
                    $data=[
                        "orderCode"=>$info['orderCode'],
                        "th_type"=>2,
                        "th_num"=>$info['error_num'],
                        "th_fee"=>round($info['error_num']*$sale['sale_price'],2),
                        "thCode"=>$info['returnCode'],
                        "spuCode"=>$sale['good_code'],
                        "good_name"=>$sale['good_name'],
                        "cat_id"=>$sale['cat_id'],
                        "apply_id"=>$info['apply_id'],
                        "apply_name"=>$info['apply_name'],
                        "addtime"=>date("Y-m-d H:i:s"),
                        "status"=>1,
                        "is_del"=>0
                    ];
                    $inse=Db::name("th_data")->insert($data);
                    if($inse==false){
                        Db::rollback();
                        return error_show(1004,"退回单更新失败");
                    }
                }
                $order = ["order_code"=>$info['returnCode'],"status"=>$var,"action_remark"=>'',"action_type"=>"edit"];
                ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname],$order,"SHD", $info['status'],$this->post);

//                switch ($status) {
//                    //待采购审核
//                    case 2:
//                        $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var, 'wait_id' => $info['person_id'], 'wait_name' => $info['person'], 'holder_id' => $info['person_id']];
//                        break;
//
//                    //待设置仓库
//                    case 3:
//                        $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var, 'wait_id' => $info['cgderid'], 'wait_name' => $info['cgder'], 'holder_id' => $info['cgderid']];
//                        break;
//
//                    //待客户退货
//                    case 4:
//                        $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var, 'wait_id' => $info['apply_id'], 'wait_name' => $info['apply_name'], 'holder_id' => $info['apply_id']];
//                        break;
//
//                    default:
//                        $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var, 'holder_id' => $info['apply_id']];
//                }
//                if (in_array($status, [2, 3])) $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var, 'wait_id' => $info['cgderid'], 'wait_name' => $info['cgder'],'holder_id'=>$info['cgderid']];
//                elseif ($status == 4) $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var, 'wait_id' => $info['apply_id'], 'wait_name' => $info['apply_name'],'holder_id'=>$info['apply_id']];
//                else $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var,'holder_id'=>$info['apply_id']];
                $process = ["order_code" => $info['returnCode'], "order_id" => $info['id'], "order_status" => $status, "order_type" => "SHD", "before_status" => $var, 'wait_id' => $info['person_id'], 'wait_name' => $info['person'], 'holder_id' => $info['person_id']];

                ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname],$process);
                Db::commit();
                return app_show(0,"更新成功");
            }else{
                Db::rollback();
                return error_show(1004,"更新失败");
            }
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }

    }

    public function setWsm(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        if($info['status']!=3){
            return error_show(1005,"采购主管未审核无法设置退回仓库");
        }
        $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code']!="" ? trim($this->post['wsm_code']) :"";
        if($info['return_tag']==2) {
            if($wsm_code==""){
                return error_show(1005,"参数 wsm_code 不能为空");
            }
           $warehouse =Db::name("warehouse_info")->where(["wsm_code"=>$wsm_code])->find();
            if($warehouse==false){
                return error_show(1005,"仓库数据未找到");
            }
            $wareaddr =Db::name("warehouse_addr")->where(["wsm_code"=>$wsm_code,"is_del"=>0,"status"=>1])->find();
        }
        $addrcode=isset($this->post['addr_code'])&&$this->post['addr_code']!=""?$this->post['addr_code']:"";
        if($addrcode==""){
            return error_show(1005,"参数 addr_code 不能为空");
        }
        $addr=isset($this->post['addr'])&&$this->post['addr']!=""?trim($this->post['addr']):"";
        if($addr==""){
            return error_show(1005,"参数 addr 不能为空");
        }
        $mobile=isset($this->post['mobile'])&&$this->post['mobile']!=""?trim($this->post['mobile']):"";
        if($mobile==""){
            return error_show(1005,"参数 mobile 不能为空");
        }
        $contactor=isset($this->post['contactor'])&&$this->post['contactor']!=""?trim($this->post['contactor']):"";
        if($contactor==""){
            return error_show(1005,"参数 contactor 不能为空");
        }
        $returninfo=[
            "returnCode"=>$bkcode,
            "return_wsm"=>$wsm_code,
            "contactor"=>$contactor,
            "mobile"=>$mobile ,
            "addr"=>$addr,
            "addr_code"=>$addrcode,
            "addtime"=>date("Y-m-d H:i:s")
        ];
        Db::startTrans();
        try {
            $in=Db::name("order_returninfo")->insert($returninfo);
            if($in){
                if($info['return_tag']==2 &&$wareaddr==false) {
                        $addrs =[
                            "wsm_code"=>$wsm_code,
                            "wsm_type"=>1,
                            "wsm_name"=>$contactor,
                            "wsm_addr"=>$addr,
                            "addr_code"=>$addrcode,
                            "wsm_mobile"=>$mobile,
                            "status"=>'1',
                            "is_del"=>'0',
                            "addtime"=>date("Y-m-d H:i:s"),
                            "updatetime"=>date("Y-m-d H:i:s")
                        ];
                    $wareaddr =Db::name("warehouse_addr")->insert($addrs);
                    if($wareaddr==false){
                        Db::rollback();
                        return app_show(1004,"退货仓库地址录入失败");
                    }
                }
                $old_info_status = $info['status'];
                $info['status']=4;
                $info["updatetime"]=date("Y-m-d H:i:s");
                $up =Db::name("order_return")->save($info);
                if($up){

                    //修改状态，添加待办
                    ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname], [
                        "order_code" => $info['returnCode'],//销售单code
                        "status" => $old_info_status,//这里的status是之前的值
                        "action_remark" => '',//备注
                        "action_type" => "status"//新建create，编辑edit，更改状态status
                    ], "SHD", $info['status'], $info);

                    ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname], [
                        "order_type" => 'SHD',
                        "order_code" => $info['returnCode'],//销售单code
                        "order_id" => $info['id'],
                        "order_status" => $info['status'],
                        "before_status"=>$old_info_status,
                        'holder_id'=>$info['apply_id']
                    ]);

                    Db::commit();
                    return app_show(0,"退货仓库设置成功");
                }
            }
            Db::rollback();
            return error_show(1004,"设置失败");
        }catch (\Exception $e){
        Db::rollback();
        return error_show(1004,$e->getMessage());
        }
    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function postfeed(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $contactor = isset($this->post['contactor']) && $this->post['contactor']!="" ? trim($this->post['contactor']) :"";

        $mobile = isset($this->post['mobile']) && $this->post['mobile']!="" ? trim($this->post['mobile']):"";

        $addr = isset($this->post['addr']) && $this->post['addr']!="" ? trim($this->post['addr']):"";
        $addr_code = isset($this->post['addr_code']) && $this->post['addr_code']!=""&&!empty($this->post['addr_code']) ?
            $this->post['addr_code']:"";
        $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
        if($wsm_code==""){
                return error_show(1005,"参数 wsm_code不能为空");
        }
        if($info['is_th']==0&&$info['order_type']==1) {
            $wsm = Db::name("warehouse_info")->where(["wsm_code" => $wsm_code])->find();
            if (empty($wsm)) {
                return error_show(1005, "未找到仓库数据");
            }
            $sm = Db::name("warehouse_addr")->where(["wsm_code" => $wsm_code,"is_del"=>0])->find();
            $contactor==""?(isset($sm['wsm_name']) ?  $contactor=$sm['wsm_name']:""):"";
            $sm['wsm_name'] =isset($sm['wsm_name']) ? $sm['wsm_name']:"";
            $mobile==""?(isset($sm['wsm_mobile']) ?  $mobile=$sm['wsm_mobile']:""):"";
            $sm['wsm_mobile'] =isset($sm['wsm_mobile']) ? $sm['wsm_mobile']:"";
            $addr==""?(isset($sm['wsm_addr']) ?  $addr=$sm['wsm_addr']:""):"";
            $sm['wsm_addr'] =isset($sm['wsm_addr']) ? $sm['wsm_addr']:"";
            $addr_code==""?(isset($sm['addr_code']) ?  $addr=$sm['addr_code']:""):"";
            $sm['addr_code'] =isset($sm['addr_code']) ? $sm['addr_code']:"";
        }

        $remark = isset($this->post['remark']) && $this->post['remark']!="" ? trim($this->post['remark']):"";
        if($info['is_th']==1 && $info['order_type']==1){
            if($contactor==''){
                return error_show(1005,"参数 contactor 不能为空");
            }
            if($mobile==''){
                return error_show(1005,"参数 mobile 不能为空");
            }
            if($addr==''){
                return error_show(1005,"参数 addr 不能为空");
            }
            if($addr_code==''){
                return error_show(1005,"参数 addr_code 不能为空");
            }
            if($addr_code!==''&&is_array($addr_code)){
                $addrs=[];
                $addrs['provice_code'] = $addr_code[0];
                $addrs['city_code'] = $addr_code[1];
                $addrs['area_code'] = $addr_code[2];
                $addr_code = json_encode($addrs);
            }
        }

        Db::startTrans();
        try{
            $var=$info['status'];
            $info['status']=$info['order_type']==1?3:4;
            $info['remark']=$remark;
            $info['updatetime']=date("Y-m-d H:i:s");
            $up =Db::name("order_return")->save($info);
            if($up){

                //  var_dump($contactor);
                $returninfo = Db::name("order_returninfo")->where(["returnCode"=>$bkcode])->find();
                if(empty($returninfo)){
                    $returninfo=[
                        "returnCode"=>$bkcode,
                        "return_wsm"=>$wsm_code,
                        "contactor"=>$contactor,
                        "mobile"=>$mobile ,
                        "addr"=>$addr,
                        "addr_code"=>$addr_code,
                        "addtime"=>date("Y-m-d H:i:s")
                    ];
                }else{
                    $returninfo['return_wsm'] = $wsm_code;
                    //if($info['is_th']==1 && $info['order_type']==1) {
                    $contactor !==""? $returninfo['contactor'] = $contactor:"";
                    $mobile!==""?$returninfo['mobile'] = $mobile:"";
                    $addr!==""?  $returninfo['addr'] = $addr:"";
                    $addr_code!==""?$returninfo['addr_code'] = $addr_code:"";
                   // }
                }
//                var_dump($contactor);
//                var_dump($returninfo);
                $in=Db::name("order_returninfo")->save($returninfo);
                if($in){
                    $order = ["order_code"=>$info['returnCode'],"status"=>$var,"action_remark"=>'',"action_type"=>"edit"];
                    ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname],$order,"SHD",$info['status'],$this->post);
                    $process=["order_code"=>$info['returnCode'],"order_id"=>$info['id'],"order_status"=>$info['status'],"order_type"=>"SHD","before_status"=>$var,'holder_id'=>$info['apply_id']];
                    ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname],$process);
                    Db::commit();
                    return app_show(0,"更新成功");
                }
            }
            Db::rollback();
           return error_show(1004,"更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }

    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function addpost(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $return_info = Db::name("order_returninfo")->where(['returnCode'=>$bkcode])->find();
        if(empty($return_info)){
            $return_info=[
                "returnCode"=>$bkcode,
                "return_wsm"=>'',
                "contactor"=>'',
                "mobile"=>'',
                "addr"=>'',
                "addr_code"=>'',
                "addtime"=>date("Y-m-d H:i:s"),
                "post_company"=>'',
                "post_code"=>'',
                "post_fee"=>'',
            ];
        }
          $post_own = isset($this->post['own']) &&$this->post['own']!='' ? trim($this->post['own']):"";
        if($post_own==''){
            return error_show(1005,"参数own不能为空");
        }
        $info['post_own'] = $post_own;
        $post_company = isset($this->post['company'])&&$this->post['company']!='' ? trim($this->post['company']):"";
        if($post_company==''){
            return error_show(1005,"参数company不能为空");
        }
        $return_info['post_company'] = $post_company;
        $post_code = isset($this->post['post_code'])&&$this->post['post_code']!='' ? trim($this->post['post_code']):"";
        if($post_code==''){
            return error_show(1005,"参数post_code不能为空");
        }
        $return_info['post_code'] = $post_code;
        $fee= isset($this->post['post_fee'])&&$this->post['post_fee']!=='' ? round($this->post['post_fee'],2):"";
        if($fee===''){
            return error_show(1005,"参数post_fee不能为空");
        }
        $return_info['post_fee'] = $fee;
        Db::startTrans();
        try{
            $str=$info['status'];
            $info['status']=$info['order_type']==1?4:5;
            $info['updatetime']=date("Y-m-d H:i:s");
            $up =Db::name("order_return")->save($info);
            if($up){
                $order = ["order_code"=>$info['orderCode'],"status"=>$str,"action_remark"=>'',"action_type"=>"edit"];
                ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname],$order,"SHD",$info['status'],$this->post);
                $process=["order_code"=>$info['returnCode'],"order_id"=>$info['id'],"order_status"=>$info['status'],"order_type"=>"SHD","before_status"=>$str,'holder_id'=>$info['apply_id']];
                ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname],$process);
                $in=Db::name("order_returninfo")->save($return_info);
                if($in){
                    $data=[
                        'thNo'=>makeNo("ST"),
                        "orderCode"=>$info['orderCode'],
                        "order_type"=>$info['order_type'],
                        "outCode"=>$info['outCode'],
                        "returnCode"=>$info['returnCode'],
                        "good_code"=>$info['good_code'],
                        "good_name"=>$info['good_name'],
                        "return_wsm"=>$return_info['return_wsm'],
                        "return_num"=>$info['error_num'],
                        "contactor"=>$return_info['contactor'],
                        "mobile"=>$return_info['mobile'],
                        "addr"=>$return_info['addr'],
                        "addr_code"=>$return_info['addr_code'],
                        "return_code"=>$info['error_code'],
                        "return_msg"=>$info['error_msg'],
                        "post_fee"=>$return_info['post_fee'],
                        "post_code"=>$return_info['post_code'],
                        "post_company"=>$return_info['post_company'],
                        "customer_code"=>$info['customer_code'],
                        "addtime"=>date("Y-m-d H:i:s"),
                        "updatetime"=>date("Y-m-d H:i:s")
                    ];
                    $back =Db::name("order_back")->insert($data,true);
                    if($back>0){

                        //维护台账
//                        Db::name('standing_book')
//                            ->where('returnCode', $bkcode)
//                            ->update([
//                                'thNo' => $data['thNo'],
//                                'updatetime' => date("Y-m-d H:i:s")
//                            ]);

                        Db::execute("UPDATE `wsm_standing_book` SET `thNo`=CONCAT(IFNULL(`thNo`,''),',{$data['thNo']}'),`updatetime`='" . date('Y-m-d H:i:s') . "' WHERE FIND_IN_SET('{$bkcode}',`returnCode`)");//这里的returnCode可能有多个


                        $order = ["order_code"=>$data['thNo'],"status"=>0,"action_remark"=>'',"action_type"=>"create"];
                        ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname],$order,"CKTHD", 0,$data);
                        $process=["order_code"=>$data['thNo'],"order_id"=>$back,"order_status"=>0,"order_type"=>"CKTHD","before_status"=>0];
                        ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname],$process);
                        Db::commit();
                        return app_show(0,"更新成功");
                    }
                }
            }
            Db::rollback();
            return error_show(1004,"更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function GysFeed(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $isth = isset($this->post['is_th']) && $this->post['is_th']!="" ? intval($this->post['is_th']):"0";
        $contactor = isset($this->post['contactor']) && $this->post['contactor']!="" ? trim($this->post['contactor'])
            :"";
        $mobile = isset($this->post['mobile']) && $this->post['mobile']!="" ? trim($this->post['mobile']):"";
        $addr = isset($this->post['addr']) && $this->post['addr']!="" ? trim($this->post['addr']):"";
        $addr_code = isset($this->post['addr_code']) && $this->post['addr_code']!=""&&!empty($this->post['addr_code']) ? $this->post['addr_code']:"";
        $remark = isset($this->post['remark']) && $this->post['remark']!="" ? trim($this->post['remark']):"";
        if($isth==1){
            if($contactor==''){
                return error_show(1005,"参数 contactor 不能为空");
            }
            if($mobile==''){
                return error_show(1005,"参数 mobile 不能为空");
            }
            if($addr==''){
                return error_show(1005,"参数 addr 不能为空");
            }
          //  var_dump(isset($this->post['addr_code']) , $this->post['addr_code']!="",!empty($addr_code));
            if($addr_code==''){
                return error_show(1005,"参数 addr_code 不能为空");
            }
            if(is_array($addr_code)){
                $addrs=[];
                $addrs['provice_code'] = $addr_code[0];
                $addrs['city_code'] = $addr_code[1];
                $addrs['area_code'] = $addr_code[2];
                $addr_code = json_encode($addrs);
            }
        }
        $orde= Db::name("order_out")->where(["outCode"=>$info['outCode'],"is_del"=>0])->find();
        if(empty($orde)){
            return error_show(1005,"未找到出库单数据");
        }
        Db::startTrans();
        try{
            $stat=$info['status'];
            $info['status']=$info['order_status']==1?5:3;
            $info['is_th']=$isth;
            $info['updatetime']=date("Y-m-d H:i:s");
            $up =Db::name("order_return")->save($info);
            if($up){
                $returninfo = Db::name("order_returninfo")->where(["returnCode"=>$bkcode])->find();
                if(empty($returninfo)){
                    $returninfo=[
                        "returnCode"=>$bkcode,
                        "return_wsm"=>'',
                        "contactor"=>$contactor,
                        "mobile"=>$mobile ,
                        "addr"=>$addr,
                        "addr_code"=>$addr_code,
                        "gys_remark"=>$remark,
                        "addtime"=>date("Y-m-d H:i:s")
                    ];
                }else{
                    $returninfo['return_wsm'] = '';
                    $returninfo['contactor'] = $contactor;
                    $returninfo['mobile'] = $mobile;
                    $returninfo['addr'] = $addr;
                    $returninfo['gys_remark'] = $remark;
                    $returninfo['addr_code'] = $addr_code;
                }
                $in=Db::name("order_returninfo")->save($returninfo);
                if($in){
                    $order = ["order_code"=>$info['returnCode'],"status"=>$stat,"action_remark"=>'',"action_type"=>"edit"];
                    ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname],$order,"SHD", $info['status'],$this->post);
                    $process=["order_code"=>$info['returnCode'],"order_id"=>$info['id'],"order_status"=>$info['status'],"SHD","before_status"=>$stat,'holder_id'=>$info['apply_id']];
                    ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname],$process);
                    Db::commit();
                    return app_show(0,"更新成功");
                }
            }
            Db::rollback();
            return error_show(1004,"更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }

    public function GetWsm(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if($info==false){
            return error_show(1005,"未找到售后数据");
        }
        $list=[];
        if($info['is_th']==1){
            if($info["order_type"]==1){
                $out =Db::name("order_out")->where(["outCode"=>$info['outCode'],"is_del"=>0])->find();
                if(empty($out)){
                    return error_show(1005,"未找到出库单数据");
                }
                $ware = Db::name("warehouse_info")->alias("a")->leftJoin("warehouse_addr b","a.wsm_code=b.wsm_code and b.status=1 and b.is_del=0")
                    ->where(["a.status"=>1,"wsm_type"=>1,"a.is_del"=>0,"a.supplierNo"=>$out['wsm_code']])->field("a.wsm_code,a.name,b.wsm_name,b.wsm_mobile,b.wsm_addr,b.addr_code")->find();
                if(empty($ware)){
                    return error_show(1005,"未找到仓库数据");
                }
                $temp['wsm_code']=isset($ware['wsm_code'])?$ware['wsm_code']:"";
                $temp['wsm_name']=isset($ware['name'])?$ware['name']:"";
                $temp['contactor'] = isset($ware['wsm_name'])?$ware['wsm_name']:"";
                $temp['mobile'] =isset($ware['wsm_mobile'])?$ware['wsm_mobile']:"";
                $temp['addr'] =isset($ware['wsm_addr'])?$ware['wsm_addr']:"";
                $temp['addr_code'] = isset($ware['addr_code'])?$ware['addr_code']:"";
                $temp['addr_cn'] =GetAddr( $ware['addr_code']);
                $list[]=$temp;
            }else {
                $returninfo = Db::name("order_returninfo")->where(["returnCode" => $bkcode])->find();
                if (empty($returninfo)) {
                    return error_show(1005, "未找到供应商仓库数据");
                }
                $data = [];
                $data['wsm_code'] = isset($returninfo['return_wsm']) && $returninfo['return_wsm'] != "" ? $returninfo['return_wsm'] : "-";
                $data['wsm_name'] = '供应商仓';
                $data['supplier_name'] = '供应商';
                $data['contactor'] = $returninfo['contactor'];
                $data['mobile'] = $returninfo['mobile'];
                $data['addr'] =  $returninfo['addr'];
                $data['addr_cn'] =GetAddr( $returninfo['addr_code']);
                $data['addr_code'] = $returninfo['addr_code'];
                $list[] = $data;
            }
        }
        $supplier = Db::name("supplier")->where(["is_platform"=>1,"status"=>1,"is_del"=>0])->column("code,name");
        if(empty($supplier)){
            return error_show(1005,"未找到供应商仓库数据");
        }
        foreach ($supplier as $value){
            $temp=[];
            $ware = Db::name("warehouse_info")->alias("a")->leftJoin("warehouse_addr b","a.wsm_code=b.wsm_code and b.status=1 and b.is_del=0")
                ->where(["a.wsm_type"=>1,"a.status"=>1,"a.is_del"=>0,"a.supplierNo"=>$value['code']])->field("a.wsm_code,a.name,b.wsm_name,b.wsm_mobile,b.wsm_addr,b.addr_code")->find();
            if(empty($ware)){
                continue;
            }
            $temp['wsm_code']=isset($ware['wsm_code'])?$ware['wsm_code']:"";
            $temp['wsm_name']=isset($ware['name'])?$ware['name']:"";
            $temp['supplier_name']=$value['name'];
            $temp['contactor'] = isset($ware['wsm_name'])?$ware['wsm_name']:"";
            $temp['mobile'] =isset($ware['wsm_mobile'])?$ware['wsm_mobile']:"";
            $temp['addr'] =isset($ware['wsm_addr'])?$ware['wsm_addr']:"";
            $temp['addr_cn'] =GetAddr($ware['addr_code']);
            $temp['addr_code'] = isset($ware['addr_code'])?$ware['addr_code']:"";
            $list[]=$temp;
        }
        return app_show(0,"获取成功",$list);
    }

    public function  setdelivery(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        if(($info['is_receive']==0&&$info['status']!=3)||($info['is_receive']==1&&$info['status']!=4) ){
            return error_show(1005,"售后单流程状态有误");
        }
        $out=Db::name("order_out")->where(["outCode"=>$info["outCode"],"is_del"=>0])->find();
        if($out==false){
            return error_show(1005,"未找到发货单数据");
        }
        $is_th = isset($this->post['is_th'])&&$this->post['is_th']!=="" ? intval($this->post['is_th']):"";
        if($is_th===""){
            return error_show(1005,"参数is_th不能为空");
        }
        $company=isset($this->post['company'])&&$this->post['company']!=""?trim($this->post['company']):"";
        $post_code=isset($this->post['post_code'])&&$this->post['post_code']!=""?trim($this->post['post_code']):"";
        $post_fee=isset($this->post['post_fee'])&&$this->post['post_fee']!==""?floatval($this->post['post_fee']):"";
        if($is_th==1){
            if($company==""){
                return error_show(1005,"参数company不能为空");
            }
            if($post_code==""){
                return error_show(1005,"参数post_code不能为空");
            }
            if($post_fee===""){
                return error_show(1005,"参数post_fee不能为空");
            }
        }
        $sale= Db::name('sale')->where(['orderCode'=>$info['orderCode'],"is_del"=>0])->find();
        if($sale==false){
            Db::rollback();
            return error_show(1004,"未找到销售单数据");
        }
        Db::startTrans();
        try {
            $returninfo = Db::name("order_returninfo")->where(["returnCode"=>$bkcode])->find();
            if($returninfo==false){
                $returninfo=[
                    "returnCode"=>$bkcode,
                    "return_wsm"=>"",
                    "contactor"=>"",
                    "mobile"=>"",
                    "addr"=>"",
                    "addr_code"=>"",
                    "post_code"=>$post_code,
                    "post_company"=>$company,
                    "post_fee"=>$post_fee,
                    "gys_remark"=>"",
                    "addtime"=>date("Y-m-d H:i:s")
                ];
            }else{
                $returninfo['post_fee']=$post_fee;
                $returninfo['post_company']=$company;
                $returninfo['post_code']=$post_code;
            }
            $up =Db::name("order_returninfo")->save($returninfo);
            if($up){
                $old_info_status = $info['status'];
                $info['status']=5;
                $info['updatetime']=date("y-m-d H:i:s");
                $ro =Db::name("order_return")->save($info);
                if($ro){

                    //修改状态，添加待办
                    ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname], [
                        "order_code" => $info['returnCode'],//销售单code
                        "status" => $old_info_status,//这里的status是之前的值
                        "action_remark" => '',//备注
                        "action_type" => "status"//新建create，编辑edit，更改状态status
                    ], "SHD", $info['status'], $this->post);

                    ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname], [
                        "order_type" => 'SHD',
                        "order_code" => $info['returnCode'],//销售单code
                        "order_id" => $info['id'],
                        "order_status" => $info['status'],
                        "before_status"=>$old_info_status,
                        'holder_id'=>$info['apply_id']
                    ]);

                    $thNo =makeNo("ST");
                    $thdata=[
                        "thNo"=>$thNo,
                        "orderCode"=>$out["orderCode"],
                        "outCode"=>$out["outCode"],
                        "order_type"=>$info["order_type"],
                        "returnCode"=>$info["returnCode"],
                        "good_code"=>$info["good_code"],
                        "good_name"=>$info["good_name"],
                        "return_wsm"=>$returninfo["return_wsm"],
                        "total_fee"=>round($sale['sale_price']*$info["error_num"],2),
                        "good_price"=>$sale['sale_price'],
                        "platform_id"=>$sale['platform_id'],
                        "return_msg"=>$info["error_msg"],
                        "return_num"=>$info["error_num"],
                        "normal_num"=>0,
                        "received_num"=>0,
                        "apply_id"=>$info['apply_id'],
                        "apply_name"=>$info['apply_name'],
                        "cgder"=>$info['cgder'],
                        "cgderid"=>$info['cgderid'],
                        "person"=>$info['person'],
                        "person_id"=>$info['person_id'],
                        "contactor"=>$returninfo["contactor"],
                        "mobile"=>$returninfo["mobile"],
                        "addr"=>$returninfo["addr"],
                        "addr_code"=>$returninfo["addr_code"],
                        "return_code"=>$info["error_code"],
                        "post_fee"=>$returninfo["post_fee"],
                        "post_code"=>$returninfo["post_code"],
                        "post_company"=>$returninfo["post_company"],
                        "customer_code"=>$info["customer_code"],
                        "status"=>$info['return_tag']==1?4:1,
                        "addtime"=>date("Y-m-d H:i:s"),
                        "updatetime"=>date("Y-m-d H:i:s")
                    ];
                    $sav= Db::name("order_back")->insert($thdata,true);
                    if($sav){

                        //修改状态，添加待办
                        ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname], [
                            "order_code" => $thdata['thNo'],//销售单code
                            "status" => $thdata['status'],//这里的status是之前的值
                            "action_remark" => '',//备注
                            "action_type" => "create"//新建create，编辑edit，更改状态status
                        ], "CKTHD", $thdata['status'], $thdata);


                        //售后退货单，供应商不同意退货，退回到业务公司仓的时候，要把待办数据推给供应商负责人和库管人员
                        if($thdata['status']==1){

                            //31库管人员,41库管-张凯旋
                            $uids = Db::name('user_role')
                                ->where(['is_del' => 0, 'roleid' => [31, 41], 'status' => 1])
                                ->column('uid');

                            ProcessOrder::AddProcess(['id' => $this->uid, 'nickname' => $this->uname], [
                                "order_type" => 'CKTHD',
                                "order_code" => $thdata['thNo'],//销售单code
                                "order_id" => $sav,
                                "order_status" => $thdata['status'],
                                "before_status" => 0,
                                'handle_user_list' => implode(',', array_merge($uids,[$sale['cgderid']])),
                            ]);
                        }else{
                            ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname], [
                                "order_type" => 'CKTHD',
                                "order_code" => $thdata['thNo'],//销售单code
                                "order_id" => $sav,
                                "order_status" => $thdata['status'],
                                "before_status"=>0
                            ]);
                        }




                        //维护台账记录
//                        Db::name('standing_book')
//                            ->where(['returnCode' => $bkcode])
//                            ->update([
//                                'thNo' => $thNo,
//                                'updatetime' => date("Y-m-d H:i:s")
//                            ]);
                        Db::execute("UPDATE `wsm_standing_book` SET `thNo`=CONCAT(IFNULL(`thNo`,''),',{$thNo}'),`updatetime`='" . date('Y-m-d H:i:s') . "' WHERE FIND_IN_SET('{$bkcode}',`returnCode`)");//这里的returnCode可能有多个
						 // 库存品退货 不退商品 需要计算成本
//						if($info['except_code']==1){
//							$sabebn =Db::name("sale_info")->where(["orderCode"=>$info['orderCode']])->select()->toArray();
//                            	 if(!empty($sabebn)){
//                        	$total_num =$info["error_num"];
//                        	foreach ($sabebn as $ve){
//
//                        		$tempnum=0;
//                        		if ($total_num==0) break;
//                        		if($total_num>=$ve['num']){
//                        			$tempnum = $ve['num'];
//                        			$total_num-=$ve['num'];
//                        			$ve['num']=0;
//                        		}else{
//                        		    $tempnum = $total_num;
//                        			$ve['num']-=$total_num;
//                        			$total_num=0;
//                        		}
//                        		$bnin=GoodStockInfo::ReturnAdd($stockid,$ve['bnCode'],$tempnum,$ve['stockid']);
//                        		if($bnin==false){
//                        			 Db::rollback();
//                                    return error_show(1005, '可售商品Bn库存数入库失败');
//                        		}
//								$up=Db::name("sale_info")->save($ve);
//                        		if($up==false){
//                        			 Db::rollback();
//                                    return error_show(1005, '可售商品Bn库存数入库失败');
//                        		}
//								$bnin=GoodStockInfo::ReturnBn($info['returnCode'],$ve['id'],$tempnum);
//                        		if($bnin==false){
//                        			 Db::rollback();
//                                    return error_show(1005, '可售商品Bn库存数入库失败');
//                        		}
//                        	}
//                        }
//						}else{
//
//						}
                        if($info['return_tag']==1){
                            $sale['th_num']+= $info['error_num'];
                            if($sale['th_num']==$sale['send_num']&& $sale['wsend_num']==0){
                                $sale['status']=3;
                            }
                            $sale['th_fee']+= round($info['error_num']*$sale['sale_price'],2);
                            $sale['updatetime']= date("Y-m-d H:i:s");
                            $uap=Db::name("sale")->save($sale);
                            if($uap==false){
                                Db::rollback();
                                return error_show(1005,'销售单订单更新失败');
                            }
                            if($sale['is_stock']==0){
                            	 $ordernum =Db::name("order_num")->where(['orderCode'=>$info['orderCode']])->find();
	                            if($ordernum==false){
	                                Db::rollback();
	                                return error_show(1005,'未找到关联采购单');
	                            }
	                            $ordernum['send_num']-=$info['error_num'];
	                            $orderup =Db::name("order_num")->save($ordernum);
	                            if($orderup==false){
	                                Db::rollback();
	                                return error_show(1005,'关联数据更新失败');
	                            }
	                            $cgd =Db::name("purchease_order")->where(["cgdNo"=>$ordernum['cgdNo'],"is_del"=>0])->find();
	                            if($cgd==false){
	                                Db::rollback();
	                                return error_show(1005,'未找到采购单数据');
	                            }
	                            $cgd['th_num']+=  $info['error_num'];
	                            if($cgd['th_num']==$cgd['send_num']&& $cgd['wsend_num']==0){
	                                $cgd['status']=4;
	                            }
	                            $cgd['th_fee']+=  round($info['error_num']*$cgd['good_price'],2);
	                            $cgd['updatetime']= date("Y-m-d H:i:s");
	                            $cgdup =Db::name("purchease_order")->save($cgd);
	                            if($cgdup==false){
	                                Db::rollback();
	                                return error_show(1005,'采购单数据更新失败');
	                            }
                            }

                                $sabebn =Db::name("sale_info")->where(["orderCode"=>$info['orderCode']])->select()->toArray();
                            	 if(!empty($sabebn)){
		                            $total_num =$info["error_num"];
		                            foreach($sabebn as $ve){
		                                $tempnum=0;
		                                if ($total_num==0) break;
		                                if($total_num>=$ve['num']){
		                                    $tempnum = $ve['num'];
		                                    $total_num-=$ve['num'];
		                                    $ve['th_num']+=$ve['num'];
		                                    $ve['num']=0;
		                                }else{
		                                    $tempnum = $total_num;
		                                    $ve['num']-=$total_num;
		                                    $ve['th_num']+=$total_num;
		                                    $total_num=0;
		                                }

		                                if( $info['except_code']==1){
//		                                	if($sale['is_stock']==1){
//		                                		$bnin=GoodStockInfo::AddBn($ve['stockid'],$ve['bnCode'],$tempnum);
//				                                if($bnin==false){
//				                                     Db::rollback();
//				                                    return error_show(1005, '可售商品Bn库存数入库失败');
//				                                }
//		                                	}
				                                $up=Db::name("sale_info")->save($ve);
				                                if($up==false){
				                                     Db::rollback();
				                                    return error_show(1005, '可售商品Bn库存数入库失败');
				                                }
		                                	}

										$bnin=GoodStockInfo::ReturnBn($info['returnCode'],$ve['id'],$tempnum);
		                                if($bnin==false){
		                                     Db::rollback();
		                                    return error_show(1005, '可售商品Bn库存数入库失败');
		                                }
		                            }
                        }
                            if($info['error_num']>=$out['send_num']){
                                    $out['status']=4;
                                    $out['updatetime']=date("Y-m-d H:i:s");
                                    $upout =Db::name("order_out")->save($out);
                                    if($upout==false){
                                        Db::rollback();
                                        return error_show(1005,'出库单数据更新失败');
                                    }
                            }
                            $data=[
                                "orderCode"=>$info['orderCode'],
                                "th_type"=>3,
                                "th_num"=>$info['error_num'],
                                "th_fee"=>round($sale['sale_price']*$info["error_num"],2),
                                "thCode"=>$thNo,
                                "spuCode"=>$sale['good_code'],
                                "good_name"=>$sale['good_name'],
                                "cat_id"=>$sale['cat_id'],
                                "apply_id"=>$info['apply_id'],
                                "apply_name"=>$info['apply_name'],
                                "addtime"=>date("Y-m-d H:i:s"),
                                "status"=>1,
                                "is_del"=>0
                            ];
                            $inse=Db::name("th_data")->insert($data);
                            if($inse==false){
                                Db::rollback();
                                return error_show(1004,"退货单更新失败");
                            }

                        }

                        Db::commit();
                        return app_show(0,"退货单新建成功",["thNo"=>$thNo]);
                    }
                }
            }
            Db::rollback();
            return error_show(1004,'退货失败');
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }

    //取消售后
    public function Cancel()
    {
        //接收参数
        $data = $this->request->only(['token', 'returnCode'], 'post', 'trim');

        $val = Validate::rule(['returnCode|售后单编号' => 'require']);

        if (!$val->check($data)) return error_show(1005, $val->getError());

        Db::startTrans();
        try {

            $rs = Db::name('order_return')->field('id,status,apply_id')->where([['returnCode', '=', $data['returnCode']], ['is_del', '=', 0], ['status', '<>', 8]])->find();

            if (!$rs) throw new Exception('该售后单记录不存在');

            //修改记录
            $res = Db::name('order_return')->where(['id' => $rs['id']])->update(['status' => 8, 'updatetime' => date('Y-m-d H:i:s')]);

            if (!$res) throw new Exception('该售后单记录修改失败');

            //记录日志
            ActionLog::logAdd($data['token'], ["order_code" => $data['returnCode'], "status" => $rs['status'], "action_remark" => '', "action_type" => "delete"], 'SHD', 8, $this->post);
            ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname], ["order_code" => $data['returnCode'], "order_id" => $rs['id'], "order_status" => 8, "order_type" => 'SHD',"before_status"=>$rs['status'],'holder_id'=>$rs['apply_id']]);

            //提交
            Db::commit();

            return app_show(0, "取消成功");

        } catch (\Exception $e) {

            Db::rollback();

            return error_show(1004, $e->getMessage());
        }

    }


    //根据审核完成的售后申请单，创建新的销售单和采购单
    public function createSaleAndCgdByAfter()
    {

        $param = $this->request->only(['token', 'returnCode'], 'post', 'trim');

        $val = Validate::rule(['token' => 'require', 'returnCode|售后申请单编号' => 'require']);

        if (!$val->check($param)) return error_show(1005, $val->getError());

        //查询售后申请单详情
        $info = Db::name('order_return')
            ->where('returnCode', $param['returnCode'])
            ->where('is_del', 0)
            ->find();

        if (empty($info)) return error_show(1005, '该售后申请单不存在');

        if ($info['status'] != 5) return error_show(1005, '该售后申请单尚未审核完成');
        if ($info['is_reissue'] == 1) return error_show(1005, '该售后申请单已完成补发，无法重复进行');

        $apply_id = GetUserInfo($param['token']);
        if (empty($apply_id) || $apply_id['code'] != 0) return error_show(1002, "申请人数据不存在");

        $rm = isset($apply_id["data"]['id']) ? $apply_id["data"]['id'] : "";
        $ri = isset($apply_id["data"]['nickname']) ? $apply_id["data"]['nickname'] : "";

        //原本销售单信息
        $old_sale = Db::name('sale')->where(['is_del' => 0, 'orderCode' => $info['orderCode']])->find();
        if (empty($old_sale)) return error_show(1005, '没有对应的销售单信息');

        //发货单信息
        $old_out = Db::name('order_out')->where(['is_del' => 0, 'orderCode' => $info['orderCode'], 'outCode' => $info['outCode']])->find();
        if (empty($old_out)) return error_show(1005, '没有对应的发货单信息');


        //根据是否咨询类商品，分别处理
        if ($info['order_type'] == 3) return $this->createSaleZixun($info['id'], $info['good_code'], $info, $old_sale, $rm, $ri, $old_out['addrid'], $param['token']);
        else return $this->createSaleNotZixun($info['id'], $info['good_code'], $info, $old_sale, $rm, $ri, $old_out, $param['token']);

    }

    /**
     * 咨询类商品处理
     * @param int $orid 对应售后记录的id
     * @param string $spuCode 商品的spuCode
     * @param array $info 售后申请单的详情
     * @param array $old_sale 原始销售订单
     * @param int $rm 操作人id
     * @param string $ri 操作人名称
     * @param int $addrid 原始发货单的地址id
     * @param string $token 当前用户的token
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    private function createSaleZixun(int $orid = 0, string $spuCode = '', array $info = [], array $old_sale = [], int $rm = 0, string $ri = '', int $addrid = 0, string $token = '')
    {
//        $bidNo =isset($this->post['bidNo'])&&$this->post['bidNo']!="" ?  trim($this->post['bidNo']):"";
//        if($bidNo==""){
//            return error_show(1003,"参数bidNo不能为空");
//        }

        $zxinfo = Db::name("consult_bids")->where(["bidNo" => $old_sale['zxNo'], "is_del" => 0])->find();
        if ($zxinfo == false) return error_show(1005, '未找到咨询单商品信息');

//        if($zxinfo['status']!=6){
//            return error_show(1003,"咨询单状态有误无法转单");
//        }
//        $zx =Db::name("consult_info")->where(["infoNo"=>$zxinfo['infoNo'],"is_del"=>0])->find();
//        if($zx==false){
//            return error_show(1003,"未找到咨询单信息");
//        }
//        if($zx['status']!=4){
//            return error_show(1003,"咨询单状态有误无法转单");
//        }
//        $zxorder =Db::name("consult_order")->where(["zxNo"=>$zx["zxNo"],"is_del"=>0])->find();
//        if($zxorder==false){
//            return error_show(1003,"未找到咨询单信息");
//        }
//        $good_num =isset($this->post['good_num'])&&$this->post['good_num']!="" ?  intval($this->post['good_num']):"";
//        if($good_num===""){
//            return error_show(1003,"参数 good_num 不能为空");
//        }
        $good_num = $info['error_num'];
        $sale_price = 0;
//        $sale_price = isset($this->post['sale_price']) && $this->post['sale_price'] != "" ? floatval($this->post['sale_price']) : "";
//        if ($sale_price === "") {
//            return error_show(1003, "参数 sale_price 销售单价 不能为空");
//        }
//        if ($sale_price < $zxinfo['sale_price']) {
//            return error_show(1003, "修改的销售单价不能低于原来的销售单价");
//        }
//        $sendtype = isset($this->post['sendtype'])&&$this->post['sendtype']!="" ? intval($this->post['sendtype']):"";
//        if($sendtype==""){
//            return error_show(1003,"参数sendtype不能为空");
//        }

//        $remark = isset($this->post['remark'])&&$this->post['remark']!="" ? trim($this->post['remark']):"";

        $orderCode = makeNo("QR");
//        $spuCode = $zxinfo['spuCode'];
        $skuCode = "";
//        $is_stock=0;

        //原有采购单信息
        $old_cgd = Db::name('order_num')
            ->alias('on')
            ->field('on.id onid,po.*')
            ->leftJoin('purchease_order po', 'po.cgdNo=on.cgdNo')
            ->where('on.orderCode', $old_sale['orderCode'])
            ->find();

        $cgd = array_merge($old_cgd, [
            'id' => null,
//            "supplierNo"=>$zxinfo['supplierNo'],
//            "companyNo"=>$zxorder['companyNo'],
            "spuCode" => $spuCode,
            "skuCode" => $skuCode,
            "orderCode" => $orderCode,
//            "good_name"=>$zxinfo['good_name'],
            "sale_price" => $old_cgd['good_price'],//采购单价格不为0，取原采购单的价格
            "total_fee" => round($old_cgd['good_price'] * $good_num, 2),
//            "pakge_fee"=>$zxinfo['pakge_fee'],
//            "cert_fee"=>$zxinfo['cert_fee'],
//            "open_fee"=>$zxinfo['open_fee'],
            'cost_fee' => $old_cgd['teach_fee'],
//            $old_sale['cost_fee']=$old_sale['teach_fee'];
//            "mark_fee"=>$zxinfo['mark_fee'],
//            "demo_fee"=>$zxinfo['demo_fee'],
//            "nake_fee"=>$zxinfo['nake_fee'],
//            "delivery_fee"=>$zxinfo['delivery_fee'],
            "good_num" => $good_num,
            "createrid" => $rm,
            "creater" => $ri,
            "good_type" => 1,
//            "weight"=>$zxinfo['good_weight'],
//            "gold_price"=>$zxinfo['gold_price'],
//            "is_diff"=>$zxinfo['is_diff'],
            "order_type" => 3,//咨询商品
            "order_source" => 6,//6售后补换货
//            'send_way'=>$zxinfo['send_way']
            'token' => $token,
            'good_createrid' => $zxinfo['createrid'],
            'good_creater' => $zxinfo['creater'],//商品创建人
        ]);
//        $token=isset($this->post['token'])&&$this->post['token']!=""? trim($this->post['token']):"";
//        if($token==""){
//            return error_show(102, "参数token不能为空");
//        }
//        $apply_id = GetUserInfo($token);
//        if (empty($apply_id) || $apply_id['code'] != 0) {
//            return error_show(102, "申请人数据不存在");
//        }
//        $rm = isset($apply_id["data"]['id']) ? $apply_id["data"]['id'] : "";
//        $ri = isset($apply_id["data"]['nickname']) ? $apply_id["data"]['nickname'] : "";

//        $va = isset($this->post['order_addr']) && $this->post['order_addr'] !== "" ? $this->post['order_addr'] : "";
//        $send_num=0;
//        if($sendtype==1){
//            if ($va == "") {
//                return error_show(1002, "参数order_addr不能为空");
//            }
//            $send_num = array_sum(array_column($va,"receipt_quantity"));
//        }
//        if($good_num<$send_num){
//            return error_show(1002, "发货数量不能超过购买数量");
//        }
//        $arrtime=isset($this->post['arrtime'])&&$this->post['arrtime']!="" ?$this->post['arrtime']:"";
//        if($arrtime==""){
//            return error_show(1002, "参数arrtime不能为空");
//        }

        //新加字段
//        $platform_order=isset($this->post['platform_order'])&&$this->post['platform_order']!="" ?$this->post['platform_order']:"";
//        $workNo=isset($this->post['workNo'])&&$this->post['workNo']!="" ?$this->post['workNo']:"";
//        $proof_type = isset($this->post['proof_type']) && $this->post['proof_type'] != "" ? intval($this->post['proof_type']) : 0;
//        $proof_url = isset($this->post['proof_url']) && $this->post['proof_url'] != "" ? trim($this->post['proof_url']) : '';


        Db::startTrans();
        try {
//            $zx =Db::name("consult_info")->where(["infoNo"=>$zxinfo['infoNo'],"is_del"=>0])->lock(true)->find();
//            if($zx==false){
//                Db::rollback();
//                return error_show(1003,"未找到咨询单信息");
//            }
            $supplier_temp_info = Db::name('supplier')
                ->field('id,person,personid')
                ->where('code',$old_cgd['supplierNo'])
                ->findOrEmpty();

            $data = array_merge($old_sale, [
                'id' => null,
                "orderCode" => $orderCode,
                "good_code" => $spuCode,
//                "skuCode"=>$skuCode,
//                "customer_code"=>$zxorder['khNo'],
//                "good_name"=>isset($zxinfo['good_name'])&&$zxinfo['good_name']!==''?$zxinfo['good_name']:'',
                "good_num" => $good_num,
//                "cat_id"=>$zxinfo['cat_id'],
                "apply_id" => $rm,
                "apply_name" => $ri,
//                "origin_price"=>$zxinfo['total_fee'],
//                "sale_price" => $old_sale['sale_price'],//取原价格
//                "post_fee"=>0,
                "status" => 0,
                "send_status" => 0,
                "th_num" => 0,
                "th_fee" => 0,//退货金额为0
                "send_num" => 0,
                "wsend_num" => $good_num,
//                "send_status"=>1,
                "good_type" => 1,
//                "send_type"=>$sendtype,
//                "supplierNo"=>$zxorder['companyNo'],
                "is_del" => 0,
//                "zxNo"=>$bidNo,
//                "platform_order"=>$platform_order,
//                "platform_id"=> $zxorder['platform_code'],
                "remark" => $old_sale['orderCode'],
//                "arrive_time"=>$arrtime,
//                "is_stock"=>0,
//                "is_activity"=>0,
//                "proof_id"=>0,
                "order_type" => 3,
                "order_source" => 6,//6售后补换货
//                'good_weight'=>$zxinfo['good_weight'],
//                'gold_price'=>$zxinfo['gold_price'],
//                'cost_price'=>$zxinfo['sale_cost_fee'],
//                'diff_weight'=>0,
//                'diff_fee'=>0,
                "addtime" => date("Y-m-d H:i:s"),
                "updatetime" => date("Y-m-d H:i:s"),
                'returnCode' => $info['returnCode'],
//                'total_price' => round($sale_price * $good_num, 2),
//                'workNo'=>$workNo,
                'cgderid' => $supplier_temp_info['personid'],
                'cgder' => $supplier_temp_info['person'],//采购员(供应商负责人)
                'good_createrid' => $zxinfo['createrid'],
                'good_creater' => $zxinfo['creater'],//商品创建人
            ]);

            $datainfo = Db::name('sale')->insertGetId($data);
            if ($datainfo > 0) {

                $standing_book_data = [
                    'sale_id' => $datainfo,
                    'infoNo' => $zxinfo['infoNo'],
                    'updatetime' => date('Y-m-d H:i:s')
                ];

                //修改状态，添加待办
                ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname], [
                    "order_code" => $orderCode,//销售单code
                    "status" => 0,//这里的status是之前的值
                    "action_remark" => '',//备注
                    "action_type" => "create"//新建create，编辑edit，更改状态status
                ], "XSQRD", $data['status'], $data);

                ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname], [
                    "order_type" => 'XSQRD',
                    "order_code" => $orderCode,//销售单code
                    "order_id" => $datainfo,
                    "order_status" => $data['status'],
                    "before_status" => 0,
                    'holder_id' => $data['apply_id']
                ]);
//                $old_zx_status = $zx['status'];
//                $zx['status']=5;
//                $zx['updatetime']=date("Y-m-d H:i:s");
//                $sa=Db::name("consult_info")->save($zx);
//                if($sa==false){
//                    Db::rollback();
//                    return error_show(1002,"咨询单修改失败");
//                }else{
//                    //修改状态，添加待办
//                    ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname], [
//                        "order_code" => $zx['infoNo'],//咨询单详情编号
//                        "status" => $old_zx_status,//这里的status是之前的值
//                        "action_remark" => '',//备注
//                        "action_type" => "status"//新建create，编辑edit，更改状态status
//                    ], "ZXD", 5, $zx);
//
//                }
                $this->createCgd($cgd, $standing_book_data);
//                if($bol==false){
//                    Db::rollback();
//                    return error_show(1002,"咨询订单创建失败");
//                }
//                $limt=[
//                    "spuCode"=>$zxinfo['spuCode'],
//                    "good_name"=>$zxinfo['good_name'],
//                    "brand_id"=>$zxinfo['brand_id'],
//                    "good_unit"=>$zxinfo['unit_id'],
//                    "cat_id"=>$zxinfo['cat_id'],
//                    "good_type"=>0,
//                    "moq"=>1,
//                    "customized"=>$zxinfo['work_day'],
//                    "tax"=>$zxinfo['tax'],
//                    "supplierNo"=>$zxinfo["supplierNo"],
//                    "is_auth"=>0,
//                    "craft_desc"=>$zxinfo['good_name'],
//                    "good_remark"=>"",
//                    "platform_id"=>$zxorder['platform_id'],
//                    "good_img"=>$zxinfo['good_img'],
//                    "good_thumb_img"=>"",
//                    "good_info_img"=>"",
//                    "specinfo"=>$zxinfo['specinfo'],
//                    "work_day"=>$zxinfo['work_day'],
//                    "noble_metal"=>$zxinfo['metal_id'],
//                    "is_gold_price"=>$zxinfo['is_gold_price'],
//                    "config"=>$zxinfo['config'],
//                    "other_config"=>$zxinfo['other_config'],
//                    "weight"=>$zxinfo['weight'],
//                    "good_weight"=>$zxinfo['good_weight'],
//                    "is_diff"=>$zxinfo['is_diff'],
//                    "supply_area"=>$zxinfo['supply_area'],
//                    "pay_way"=>$zxinfo['pay_way'],
//                    "send_way"=>$zxinfo['send_way'],
//                    "companyNo"=>$zxorder['companyNo'],
//                    "status"=>1,
//                    "is_del"=>0,
//                    "createrid"=>$zxinfo['createrid'],
//                    "creater"=>$zxinfo['creater'],
//                    "addtime"=>date("Y-m-d H:i:s"),
//                    "updatetime"=>date("Y-m-d H:i:s"),
//                    'proof_type' => $proof_type,//凭证类型
//                    'proof_url' => $proof_url,//凭证文件
//                ];
//                $good = Db::name("good_zixun")->insert($limt);
//                if(!$good){
//                    Db::rollback();
//                    return error_show(1006,"咨询商品录入失败");
//                }
//                if(!empty($va)){
                $order = Db::name("order_num")->where(["orderCode" => $orderCode, "status" => 1])->where([["wsend_num", ">=", 0]])->find();
                if (empty($order)) throw new Exception('采购单关联数据未找到');

//                    foreach ($va as $value){
//                        $temp=[];
//                        $addrs=[];
//                        if($value['addr_code']!==''&&is_array($value['addr_code'])&&!empty($value['addr_code'])){
//                            $addrs['provice_code'] = $value['addr_code'][0];
//                            $addrs['city_code'] = $value['addr_code'][1];
//                            $addrs['area_code'] = $value['addr_code'][2];
//                            $addr = json_encode($addrs);
//                        }else{
//                            $addr = isset($value['addr_code'])?$value['addr_code']:'';
//                        }
//                        $temp['orderCode']=$orderCode;
//                        $temp['contactor']=$value['contactor'];
//                        $temp['mobile'] = $value['mobile'];
//                        $temp['addr'] = $value['addr'];
//                        $temp['addr_code']=$addr;
//                        $temp['customer_code'] =$zxorder['khNo'];
//                        $temp['receipt_quantity']=$value['receipt_quantity'];
//                        $temp['post_fee'] =0;
//                        $temp['is_del'] =0;
//                        $temp['addtime'] =date("Y-m-d H:i:s");
//                        $temp['updatetime'] =date("Y-m-d H:i:s");
//                        $temp['arrive_time']=$arrtime;
                $old_out_addr_info = Db::name('order_out')
                    ->alias('oo')
                    ->field('oo.id,oa.addr,oa.addr_code,oa.contactor,oa.mobile,oa.customer_code,oa.post_fee,oa.arrive_time')
                    ->leftJoin('order_addr oa', 'oa.id=oo.addrid')
                    ->where(['oo.outCode' => $info['outCode'], 'oo.orderCode' => $info['orderCode']])
                    ->find();

                if (empty($old_out_addr_info)) throw new Exception('发货单对应的地址信息查不到');

                $temp = [
                    'orderCode' => $orderCode,
                    'addr' => $old_out_addr_info['addr'],
                    'addr_code' => $old_out_addr_info['addr_code'],
                    'contactor' => $old_out_addr_info['contactor'],
                    'mobile' => $old_out_addr_info['mobile'],
                    'customer_code' => $old_out_addr_info['customer_code'],
                    'receipt_quantity' => $good_num,
                    'arrive_time' => $old_out_addr_info['arrive_time'],
                    'addtime' => date("Y-m-d H:i:s"),
                    'updatetime' => date("Y-m-d H:i:s"),
//                    ''=>'',
                ];
                $addrid = Db::name('order_addr')->insertGetId($temp);
//                        if($vmp>0){
                $outCode = makeNo("DF");
                $out = [
                    "orderCode" => $orderCode,
                    "outCode" => $outCode,
                    "apply_id" => $rm,
                    "apply_name" => $ri,
                    'addrid' => $addrid,
                    "post_name" => "",
                    "post_code" => "",
                    "post_fee" => 0,
                    "sendtime" => date("Y-m-d H:i:s"),
                    "send_num" => $good_num,
                    "check_num" => 0,
                    "error_num" => 0,
                    "wsm_code" => "",
                    "order_type" => 3,
                    "status" => 0,
                    "addtime" => date("Y-m-d H:i:s"),
                    "updatetime" => date("Y-m-d H:i:s")
                ];
                $ou = Db::name("order_out")->insert($out);
                if ($ou == false) throw new Exception('发货地址添加创建失败');
                else {
                    //修改状态，添加待办
                    ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname], [
                        "order_code" => $outCode,//出库单号
                        "status" => 0,//这里的status是之前的值
                        "action_remark" => '',//备注
                        "action_type" => "create"//新建create，编辑edit，更改状态status
                    ], "CKD", 0, $out);

                    ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname], [
                        "order_type" => 'CKD',
                        "order_code" => $outCode,//出库单号
                        "order_id" => Db::name("order_out")->getLastInsID(),
                        "order_status" => 0,
                        "before_status" => 0,
                        'holder_id' => $out['apply_id']
                    ]);

                    //将发货编号添加到台账中
                    $standing_book_data['outCode'][] = $outCode;
                }
                $order['send_num'] += $good_num;
                $order['wsend_num'] -= $good_num;
                if ($order['wsend_num'] < 0) throw new Exception('发货数量已超出总数');
                $ups = Db::name("order_num")->save($order);
                if ($ups) {
                    $sen = Db::name("order_send")->save([
                        "cgdNo" => $order['cgdNo'],
                        "outCode" => $outCode,
                        "send_num" => $good_num,
                        "status" => 1,
                        "addtime" => date("Y-m-d H:i:s"),
                        "updatetime" => date("Y-m-d H:i:s")
                    ]);
                    if ($sen == false) throw new Exception('发货地址添加创建失败');
                }

//                        }else{
//                            Db::rollback();
//                            return error_show(1002,"发货地址添加创建失败");
//                        }
//                    }


                //处理台账
                if (isset($standing_book_data['outCode'])) {
                    Db::execute("UPDATE `wsm_standing_book` SET `outCode`=CONCAT(IFNULL(`outCode`,''),'," . implode(',', $standing_book_data['outCode']) . "'),`updatetime`='" . date('Y-m-d H:i:s') . "' WHERE `infoNo`='{$standing_book_data['infoNo']}'");
                    unset($standing_book_data['outCode']);
                }

                Db::name('standing_book')->where('infoNo', $standing_book_data['infoNo'])->update($standing_book_data);


                Db::name('order_return')
                    ->where(['id' => $orid, 'is_reissue' => 0])
                    ->update([
                        'is_reissue' => 1,
                        'newOrderCode' => $orderCode,
                        'updatetime' => date('Y-m-d H:i:s')
                    ]);

                Db::commit();
                return app_show(0, "咨询订单创建成功", ["order_code" => $orderCode]);
            }
            Db::rollback();
            return error_show(1002, "咨询订单创建失败");
        } catch (Exception $e) {
            Db::rollback();
            return error_show(1003, $e->getMessage() . '|' . $e->getFile() . ':' . $e->getLine());
        }
    }

    private function createCgd($data,array &$standing_book_da=[]){
        $cgdCode = makeNo("CG");
        $supplier=Db::name("supplier")->where(["code"=>$data['supplierNo'],"is_del"=>0])->find();
        if($supplier==false) throw new Exception('该供应商不存在');


        $wsm= Db::name("warehouse_info")
            ->where(["supplierNo"=>$data["supplierNo"],"companyNo"=>$data['companyNo'],"wsm_type"=>2,"is_del"=>0])
            ->find();
        if($wsm==false){
            $wsm_code = makeNo("WSM");
            $inwsm=[
                "wsm_code"=>$wsm_code,
                "name"=>$supplier['name'],
                "wsm_type"=>2,
                "supplierNo"=>$supplier['code'],
                "addr"=>"",
                "addrs_code"=>"",
                "contactor"=>$data['order_type']==1? $supplier['personid']:$data['createrid'],
                "contactor_name"=>$data['order_type']==1? $supplier['person']:$data['creater'],
                "mobile"=>"",
                "position"=>"",
                "companyNo"=>$data['companyNo'],
                "status"=>1,
                "is_del"=>0,
                "addtime"=>date("Y-m-d H:i:s"),
                "updatetime"=>date("Y-m-d H:i:s")
            ];
            $in = Db::name("warehouse_info")->insert($inwsm);
            if($in==false) throw new Exception('仓库新增失败');

        }else $wsm_code =$wsm['wsm_code'];


        $cg =[
            "cgdNo"=>$cgdCode,
            "bkcode"=>"",
            "wsm_code"=>$wsm_code,
            "cgder"=>$data['good_creater'],
            "cgder_id"=>$data['good_createrid'],
            "spuCode"=>$data['spuCode'],
            "skuCode"=>$data['skuCode'],
            "good_name"=>$data['good_name'],
            "good_num"=>$data['good_num'],
            "good_price"=>$data['sale_price'],
            "total_fee"=>round($data['sale_price']*$data['good_num'],2),
            "pakge_fee"=>$data['pakge_fee'],
            "cert_fee"=>$data['cert_fee'],
            "open_fee"=>$data['open_fee'],
            "teach_fee"=>$data['cost_fee'],
            "mark_fee"=>$data['mark_fee'],
            "demo_fee"=>$data['demo_fee'],
            "nake_fee"=>$data['nake_fee'],
            "weight"=>$data['weight'],
            "delivery_fee"=>$data['delivery_fee'],
            "gold_price"=>$data['gold_price'],
            "diff_weight"=>"0",
            "diff_fee"=>"0",
            "supplierNo"=>$data['supplierNo'],
            "supplier_name"=>$supplier['name'],
            "companyNo"=>$data['companyNo'],
            "send_status"=>1,
            "send_num"=>0,
            "wsend_num"=>$data['good_num'],
            "remark"=>"",
            "status"=>0,//0初始化
            "lasttime"=>date("Y-m-d H:i:s"),
            "is_del"=>0,
            "order_type"=>$data['order_type'],
            "order_source"=>$data['order_source'],
            "good_type"=>$data['good_type'],
            "addtime"=>date("Y-m-d H:i:s"),
            "updatetime"=>date("Y-m-d H:i:s"),
            'good_createrid' => $data['good_createrid'],
            'good_creater' => $data['good_createrid'],//商品创建人
        ];
        $up =Db::name("purchease_order")->insertGetId($cg);
        if($up){
            //修改状态，添加待办
            ActionLog::logAdd(['id'=>$this->uid,'nickname'=>$this->uname], [
                "order_code" => $cg['cgdNo'],//销售单code
                "status" => 0,//这里的status是之前的值
                "action_remark" => '',//备注
                "action_type" => "create"//新建create，编辑edit，更改状态status
            ], "CGD", $cg['status'], $cg);

            ProcessOrder::AddProcess(['id'=>$this->uid,'nickname'=>$this->uname], [
                "order_type" => 'CGD',
                "order_code" => $cg['cgdNo'],//销售单code
                "order_id" => $up,
                "order_status" => $cg['status'],
                "before_status"=> 0,
                'holder_id' => $supplier['personid'],
                'wait_id' => $supplier['personid'],
                'wait_name' => $supplier['person'],
            ]);

            $standing_book_da = array_merge($standing_book_da, [
                'orderCode' => $data['orderCode'],
                'cgdNo' => $cgdCode,
                'spuCode' => $data['spuCode'],
                'skuCode' => $data['skuCode'],
                'order_type' => $data['order_type'],
                'order_source' => $data['order_source'],
                'supplierNo' => $data['supplierNo'],
                "companyNo" => $data['companyNo'],
            ]);

            $rela=[
                "orderCode"=>$data['orderCode'],
                "cgdNo"=>$cgdCode,
                "spuCode"=>$data['spuCode'],
                "good_num"=>$data['good_num'],
                "wsend_num"=>$data['good_num'],
                "send_num"=>0,
                "wait_num"=>0,
                "status"=>1,
                "source"=>2
            ];

            Db::name("order_num")->save($rela);

            $stokc =Db::name("good_stock")
                ->where(['spuCode'=>$data['spuCode'],"wsm_code"=>$wsm_code, "is_del"=>0])
                ->find();
                if($stokc==false){
                    $stokc=[
                        "spuCode"=>$data['spuCode'],
                        "wsm_code"=>$wsm_code,
                        "wait_in_stock"=>$data['good_num'],
                        "wait_out_stock"=>0,
                        "usable_stock"=>0,
                        "intra_stock"=>0,
                        "total_stock"=>0,
                        "status"=>1,
                        "addtime"=>date("Y-m-d H:i:s"),
                        "updatetime"=>date("Y-m-d H:i:s")
                    ];
                }else{
                    $stokc['wait_in_stock']+=$data['good_num'];
                    $stokc['updatetime']=date("Y-m-d H:i:s");
                }
                $stoc= Db::name("good_stock")->save($stokc);
                if($stoc==false) throw new Exception('商品仓库库存修改失败');


                $good_data[] = ['good_log_code' =>$cgdCode, "stock_id" => isset($stoc['id'])?$stoc['id']:Db::name("good_stock")->getLastInsID(), "type" => 1,'stock'=>$data['good_num'], "stock_name" => "wait_in_stock"];
                GoodLog::LogAdd($data['token'],$good_data,"CGD");
                return true;
            }else  throw new Exception('商品仓库库存修改失败');

    }


    //创建采购单

    /**
     * 非咨询类商品处理
     * @param int $orid 售后记录的id
     * @param string $spuCode 商品的spuCode
     * @param array $info 售后申请单的详情
     * @param array $old_sale 原始销售订单信息
     * @param int $rm 操作人id
     * @param string $ri 操作人名称
     * @param array $old_out 原始发货单信息
     * @param string $token 当前用户的token
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    private function createSaleNotZixun(int $orid = 0, string $spuCode = '', array $info = [], array $old_sale = [], int $rm = 0, string $ri = '', array $old_out = [], string $token = '')
    {
        $goodinfo = Db::name('good')
            ->alias('g')
            ->field('g.*,gp.skuCode')
            ->join('good_platform gp', 'gp.spuCode=g.spuCode AND gp.exam_status=6')
            ->where('g.spuCode', $spuCode)
            ->where('gp.skuCode', $old_sale['skuCode'])
            ->find();

        if (empty($goodinfo)) return error_show(1005, '查不到这个商品，或该商品已下线无法售后');

        $is_activity = $old_sale['is_activity'];
        $actcode = $old_sale['activity_code'];
        $good_num = $info['error_num'];//数量，取售后申请单中的异常数量
        $supplierNo = $old_sale['supplierNo'];
        $sale_price = 0;
        $origin_price = $old_sale['origin_price'];
        $goodtype = $old_sale['good_type'];
        $is_stock = $goodinfo['is_stock'];
        $skuCode = $goodinfo['skuCode'];
        $orderCode = makeNo("QR");

        if ($is_stock == 1) {
				$stock_num = Db::name("good_stock")->alias("a")
			            ->leftJoin("warehouse_info b", "a.wsm_code=b.wsm_code")
			            ->leftJoin("good_stock_info c", "a.id=c.stockid and c.balance_num>0")
			            ->where(["spuCode" => $spuCode, "a.is_del" => 0, "a.status" => 1, "b.wsm_type" => 5, "b.companyNo" =>$supplierNo])
			            ->sum('balance_num');
            if($stock_num <  $good_num){
              return error_show(1003, "批次库存数量不足"); //库存不足
            }
        }

        $goodinfo['cgd_gold_price'] = 0;
        if ($goodtype == 1) {
            if ($is_activity == 1) {
                $act = Db::name("activity_info")
                    ->alias("a")
                    ->leftJoin("good_activity b", "a.activity_code=b.activity_code")
                    ->where(["a.skuCode" => $skuCode, "a.activity_code" => $actcode, "a.is_del" => 0, "a.status" => 1, "b.status" => 6, "b.is_del" => 0])
                    ->find();
                if ($act == false) return error_show(1003, "未找到相关活动价");

                if ($act['moq_num'] > $good_num) return error_show(1003, "商品不满足活动价起订量{$act['moq_num']}");

                if ($act['activity_stock'] < $good_num) return error_show(1003, "商品活动库存剩余{$act['activity_stock']}");

            }
//            else {
//                $good = Db::name("good_ladder")
//                    ->where(["skuCode" => $skuCode, "is_del" => 0, "status" => 1])
//                    ->where([["min_num", "<=", $good_num]])
//                    ->order("min_num desc")
//                    ->find();
//
//                if ($good == false) return error_show(1003, "未找到相关阶梯价格");
//
//                if ($goodinfo['is_gold_price'] == 1 && $is_stock != 1) {
//                    $gold = Db::name("gold_price1")
//                        ->field('id,price')
//                        ->where(["type" => $goodinfo['noble_metal'], "is_del" => 0, "status" => 1])
//                        ->order("addtime desc")
//                        ->find();
//
//                    $goodinfo['cgd_gold_price'] = $gold["price"];
//                }
//            }

        }

        //原有采购单信息
        if ($is_stock != 1){
        	        $old_cgd = Db::name('order_num')
            ->alias('on')
            ->field('on.id onid,po.*')
            ->leftJoin('purchease_order po', 'po.cgdNo=on.cgdNo')
            ->where('on.orderCode', $old_sale['orderCode'])
            ->find();

        $cgd = array_merge($old_cgd, [
            'id' => null,
//            "supplierNo" => $ct['supplierNo'],
//            "companyNo" => $supplierNo,
            "orderCode" => $orderCode,
            "spuCode" => $spuCode,
            "skuCode" => $skuCode,
//            "good_name" => $ct['good_name'],
            "sale_price" => $old_cgd['good_price'],//采购单价格不为0，取原采购单的价格
            "total_fee" => $old_cgd['good_price'] * $good_num,
//            "pakge_fee" => isset($origin['package_fee']) ? $origin['package_fee'] : 0,
//            "cert_fee" => isset($origin['cert_fee']) ? $origin['cert_fee'] : 0,
//            "open_fee" => $ct['open_fee'],
//            "cost_fee" => isset($origin['cost_fee']) ? $origin['cost_fee'] : 0,
            'cost_fee' => $old_cgd['teach_fee'],
//            "mark_fee" => isset($origin['mark_fee']) ? $origin['mark_fee'] : 0,
//            "nake_fee" => isset($origin['nake_fee']) ? $origin['nake_fee'] : 0,
//            "delivery_fee" => isset($origin['delivery_fee']) ? $origin['delivery_fee'] : 0,
//            "demo_fee" => $ct['demo_fee'],
            "good_num" => $good_num,
//            "good_type" => $goodtype,
//            "weight" => $ct['noble_weight'],
//            "gold_price" => isset($ct['cgd_gold_price']) ? $ct['cgd_gold_price'] : 0,
//            "order_type" => $is_stock == 1 ? 1 : 2,
            "order_source" => 6,//6售后补换货
            "createrid" => $rm,
            "creater" => $ri,
//            'send_way' => 2,
            'token' => $token,
            'addtime' => date('Y-m-d H:i:s'),
            'updatetime' => date('Y-m-d H:i:s'),
            'good_createrid' => $goodinfo['createrid'],
            'good_creater' => $goodinfo['creater'],//商品创建人
        ]);
            $supplier_temp_info = Db::name('supplier')
                ->field('id,person,personid')
                ->where('code',$cgd['supplierNo'])
                ->findOrEmpty();
        }else{
        	 $supplier_temp_info = Db::name('supplier')
                ->field('id,person,personid')
                ->where('code',$goodinfo['supplierNo'])
                ->findOrEmpty();
        }

//        $addrlist = isset($this->post['addrlist']) && $this->post['addrlist'] !=="" ?$this->post['addrlist']:"";
        $send_num = 0;
//        if($sendtype==1){
//            if($addrlist=="" || empty($addrlist) ||!is_array($addrlist)){
//                return error_show(1004,"参数addrlist不能为空");
//            }
//            $send_num = array_sum(array_column($addrlist,"receipt_quantity"));
//        }
//        if($send_num>$good_num){
//            return error_show(1004,"发货数量超出订单总数量");
//        }
//        $remark =isset($this->post['remark']) && $this->post['remark'] !=="" ?trim($this->post['remark']):"";
//        $proof_id =isset($this->post['proof_id']) && $this->post['proof_id'] !=="" ?intval($this->post['proof_id']):0;

//        $apply_id = GetUserInfo($param['token']);
//        if (empty($apply_id) || $apply_id['code'] != 0) return error_show(1002, "申请人数据不存在");
//        $rm = isset($apply_id["data"]['id']) ? $apply_id["data"]['id'] : "";
//        $ri = isset($apply_id["data"]['nickname']) ? $apply_id["data"]['nickname'] : "";
        Db::startTrans();
        try {



            $data = array_merge($old_sale, [
                'id' => null,
                "orderCode" => $orderCode,
                "good_code" => $spuCode,
                "skuCode" => $skuCode,
//                "customer_code" => $info['customer_code'],
//                "good_name" => (isset($goodinfo['good_name']) && $goodinfo['good_name'] !== '') ? $goodinfo['good_name'] : '',
                "good_num" => $good_num,
//                "cat_id" => $goodinfo['cat_id'],
                "apply_id" => $rm,
                "apply_name" => $ri,
                "origin_price" => $origin_price,
//                "sale_price" => $old_sale['sale_price'],//取原价格
//                "total_price" => $sale_price,//取原总价
//                "post_fee" => 0,
//                "status" => 0,
                "th_num" => 0,
                "th_fee" => 0,//退货金额为0
                "send_num" => 0,
                "wsend_num" => $good_num,
//                "send_status" => 0,
//                "good_type" => $goodtype,
//                "send_type" => $old_sale['send_type'],
//                "supplierNo" => $supplierNo,
//                "is_del" => 0,
//                "zxNo" => "",
//                "platform_order" => $old_sale['platform_order'],
//                "platform_id" => $old_sale['platform_id'],
                "remark" => $old_sale['orderCode'],
//                "is_stock" => $is_stock,
                "is_activity" => $is_activity,
                "activity_code" => $actcode,
//                "order_type" => $is_stock == 1 ? 1 : 2,
                "order_source" => 6,//6售后补换货
//                "poNo"=>$poNo,
//                'good_weight' => $ct['noble_weight'],
//                'gold_price' => isset($ct['cgd_gold_price']) ? $ct['cgd_gold_price'] : 0,
//                'cost_price' => isset($good['cost_fee']) ? $good['cost_fee'] : 0,
//                'diff_weight' => 0,
//                'diff_fee' => 0,
//                "workNo" => '',
                'status' => 0,
                "addtime" => date("Y-m-d H:i:s"),
                "updatetime" => date("Y-m-d H:i:s"),
//                'total_price' => round($sale_price * $good_num, 2),
//                'proof_id' => $old_sale['proof_id'],
//                'paytime' => $old_sale['paytime'],
                'returnCode' => $info['returnCode'],
                'cgderid' => $supplier_temp_info['personid'],
                'cgder' => $supplier_temp_info['person'],//采购员(供应商负责人)
                'good_createrid' => $goodinfo['createrid'],
                'good_creater' => $goodinfo['creater'],//商品创建人
            ]);

            $datainfo = Db::name('sale')->insertGetId($data);
            if ($datainfo > 0) {

                //修改状态，添加待办
                ActionLog::logAdd($token, [
                    "order_code" => $orderCode,//销售单code
                    "status" => 0,//这里的status是之前的值
                    "action_remark" => '',//备注
                    "action_type" => "create"//新建create，编辑edit，更改状态status
                ], "XSQRD", 0, $this->post);

                ProcessOrder::AddProcess($token, [
                    "order_type" => 'XSQRD',
                    "order_code" => $orderCode,//销售单code
                    "order_id" => $datainfo,
                    "order_status" => 0,
                    "before_status" => 0,
                    'holder_id' => $data['apply_id']
                ]);

                if ($is_activity == 1) {
                    $actup = [
                        "activity_stock" => $act['activity_stock'] - $good_num,
                        "updatetime" => date("Y-m-d H:i:s")
                    ];
                    $actupp = Db::name("activity_info")
                        ->where(["skuCode" => $skuCode, "activity_code" => $actcode, "is_del" => 0, "status" => 1])
                        ->save($actup);
                    if ($actupp == false) throw new Exception('活动库存修改失败');

                }
                $outstatus = 0;
                $standing_book_da = ['sale_id' => $datainfo, 'customer_code' => $old_sale['customer_code'], 'skuCode' => $skuCode, 'updatetime' => date('Y-m-d H:i:s')];
                if ($is_stock == 0) $this->createCgd($cgd, $standing_book_da);
                else {
                    $outstatus = 1;
                    $stockid= Db::name("good_stock")->alias("a")
			            ->leftJoin("warehouse_info b", "a.wsm_code=b.wsm_code")
			            ->where(["spuCode" => $spuCode, "a.is_del" => 0, "a.status" => 1, "b.wsm_type" => 5, "b.companyNo" =>$supplierNo])
			            ->column('a.id');
	                        $stockinfo =GoodStockInfo::OrderBn($orderCode,$stockid,$good_num);
	                        if($stockinfo==false){
	                             throw new Exception('库存商品更新库存失败');
	                        }
//                    $bol = $this->RelaCgd([
//                        'orderCode' => $orderCode,
//                        "good_num" => $good_num,
//                        "spuCode" => $spuCode,
//                        "companyNo" => $supplierNo,
//                        "cost_fee" => isset($goodinfo['cost_fee']) ? $goodinfo['cost_fee'] : 0,
//                        'order_type' => $data['order_type'],
//                        'order_source' => $data['order_source'],
//                    ], $standing_book_da);

//                    if (isset($stock)) {
//
//                        $stck = [
//                            "usable_stock" => $stock['usable_stock'] - $good_num,
//                            "wait_out_stock" => $stock['wait_out_stock'] + $good_num,
//                            "updatetime" => date("Y-m-d H:i:s")
//                        ];
//
//                        $upad = Db::name("good_stock")->where($stock)->update($stck);
//                        if ($upad == false) throw new Exception('库存商品更新库存失败');
//                        $stockinfo =GoodStockInfo::OrderBn($orderCode,$stock['id'],$good_num);
//                        if($stockinfo==false){
//                        throw new Exception('库存商品更新库存失败'); //库存不足
//                        }
//                        //商品变动日志表，good_log_code字段存储采购单号
//                        $good_data[] = ['good_log_code' => $orderCode, "stock_id" => $stock['id'], "type" => 2, 'stock' => $good_num, "stock_name" => "usable_stock"];
//                        $good_data[] = ['good_log_code' => $orderCode, "stock_id" => $stock['id'], "type" => 1, 'stock' => $good_num, "stock_name" => "wait_out_stock"];
//                        GoodLog::LogAdd($token, $good_data, "XSQRD");
//                    }

                }

//                $old_out = Db::name('order_out')
//                    ->field('id,addrid,wsm_code')
//                    ->where(['orderCode' => $info['orderCode'], 'outCode' => $info['outCode']])
//                    ->find();


                $old_out_addr_info = Db::name('order_out')
                    ->alias('oo')
                    ->field('oo.id,oa.addr,oa.addr_code,oa.contactor,oa.mobile,oa.customer_code,oa.post_fee,oa.arrive_time')
                    ->leftJoin('order_addr oa', 'oa.id=oo.addrid')
                    ->where(['oo.outCode' => $info['outCode'], 'oo.orderCode' => $info['orderCode']])
                    ->find();

                if (empty($old_out_addr_info)) throw new Exception('发货单对应的地址信息查不到');

                $temp = [
                    'orderCode' => $orderCode,
                    'addr' => $old_out_addr_info['addr'],
                    'addr_code' => $old_out_addr_info['addr_code'],
                    'contactor' => $old_out_addr_info['contactor'],
                    'mobile' => $old_out_addr_info['mobile'],
                    'customer_code' => $old_out_addr_info['customer_code'],
                    'receipt_quantity' => $good_num,
                    'arrive_time' => $old_out_addr_info['arrive_time'],
                    'addtime' => date("Y-m-d H:i:s"),
                    'updatetime' => date("Y-m-d H:i:s"),
//                    ''=>'',
                ];
                $addrid = Db::name('order_addr')->insertGetId($temp);

                $outCode = makeNo("DF");
                $out = array_merge($old_out, [
                    'id' => null,
                    "orderCode" => $orderCode,
                    "outCode" => $outCode,
                    "apply_id" => $rm,
                    "apply_name" => $ri,
                    "addrid" => $addrid,
                    "post_name" => "",
                    "post_code" => "",
                    "post_fee" => 0,
                    "sendtime" => date("Y-m-d H:i:s"),
                    "send_num" => $good_num,
                    "check_num" => 0,
                    "error_num" => 0,
                    "wsm_code" => isset($old_out['wsm_code']) ? $old_out['wsm_code'] : '',
                    "order_type" => $is_stock == 1 ? 1 : 2,
                    "status" => $outstatus,
                    "addtime" => date("Y-m-d H:i:s"),
                    "updatetime" => date("Y-m-d H:i:s")
                ]);

                Db::name("order_out")->insert($out);
                $standing_book_da['outCode'] = $outCode;

				if($is_stock==0){
					$order = Db::name("order_num")->where(["orderCode" => $orderCode, "status" => 1])->where([["wsend_num", ">=", 0]])->find();
	                if (empty($order)) throw new Exception('采购单关联数据未找到');
	                $order['send_num'] += $good_num;
	                $order['wsend_num'] -= $good_num;
	                if ($order['wsend_num'] < 0) throw new Exception('发货数量已超出总数');
	                $ups = Db::name("order_num")->save($order);
	                if ($ups) {
	                    $sen = Db::name("order_send")->save([
	                        "cgdNo" => $order['cgdNo'],
	                        "outCode" => $outCode,
	                        "send_num" => $good_num,
	                        "status" => 1,
	                        "addtime" => date("Y-m-d H:i:s"),
	                        "updatetime" => date("Y-m-d H:i:s")
	                    ]);
	                    if ($sen == false) throw new Exception('发货地址添加创建失败');
	                }
				}


                if (!isset($standing_book_da['returnCode'])) $standing_book_da['returnCode'] = '';
                if (!isset($standing_book_da['thNo'])) $standing_book_da['thNo'] = '';
                if (!isset($standing_book_da['returnGoodCode'])) $standing_book_da['returnGoodCode'] = '';
                if (!isset($standing_book_da['wsm_in_code'])) $standing_book_da['wsm_in_code'] = '';
                if (!isset($standing_book_da['cgdReturnCode'])) $standing_book_da['cgdReturnCode'] = '';

                //处理台账
                Db::name('standing_book')->insert(array_merge($standing_book_da, ['addtime' => date('Y-m-d H:i:s'), 'updatetime' => date('Y-m-d H:i:s'), 'standBookNo' => makeNo('IO')]));


                //维护售后申请单
                Db::name('order_return')
                    ->where(['id' => $orid, 'is_reissue' => 0])
                    ->update([
                        'is_reissue' => 1,
                        'newOrderCode' => $orderCode,
                        'updatetime' => date('Y-m-d H:i:s')
                    ]);

                Db::commit();
                return error_show(0, "操作成功");
            } else throw new Exception('咨询订单创建失败');
        } catch (\Exception $e) {
            Db::rollback();
            return error_show(1005, $e->getMessage() . '|' . $e->getFile() . '|' . $e->getLine());
        }
    }

    //创建采购单

    public function RelaCgd($outinfo,array &$standing_book_da=[]){
        $cgd = Db::name("order_bk")->where([["spuCode","=",$outinfo['spuCode']],["is_del","=",0],["balance_num",">=",$outinfo['good_num']],['companyNo',"=",$outinfo['companyNo']]])->lock(true)->find();
        if($cgd==false) throw new  Exception('未查询到备库单信息');


        $good=Db::name("good")
            ->where(["spuCode"=>$outinfo['spuCode'],"is_del"=>0])
            ->find();
        if($good==false) throw new  Exception('未查询到商品信息');

        $cgdinfo =Db::name("purchease_order")
            ->where(['cgdNo'=>$cgd['cgdNo'],"is_del"=>0])
            ->find();
        if($cgdinfo==false) throw new  Exception('未查询到采购单信息');

        $QrdCgd=[
            "cgdNo"=>makeNo("CG"),
            "bkcode" => $cgdinfo['bkcode'],
            'wsm_code'=>$cgdinfo['wsm_code'],
            "cgder_id"=>$cgdinfo['cgder_id'],
            "cgder"=>$cgdinfo['cgder'],
            "spuCode"=>$cgdinfo['spuCode'],
            "good_name"=>$cgdinfo['good_name'],
            "good_num"=>$outinfo['good_num'],
            "good_price"=>$cgdinfo['good_price'],
            "total_fee"=>round($cgdinfo['good_price']*$outinfo['good_num'],2),
            "pakge_fee"=>$cgdinfo['pakge_fee'],
            "cert_fee"=>$cgdinfo['cert_fee'],
            "open_fee"=>$cgdinfo['open_fee'],
            "delivery_fee"=>$cgdinfo['delivery_fee'],
            "mark_fee"=>$cgdinfo['mark_fee'],
            "teach_fee"=>$cgdinfo['teach_fee'],
            "nake_fee"=>$cgdinfo['nake_fee'],
            "demo_fee"=>$cgdinfo['demo_fee'],
            "weight"=>$cgdinfo['weight'],
            "diff_weight"=>$cgdinfo['diff_weight'],
            "diff_fee"=>$cgdinfo['diff_fee'],
            "gold_price"=>$cgdinfo['gold_price'],
            "supplierNo"=>$cgdinfo['supplierNo'],
            "supplier_name"=>$cgdinfo['supplier_name'],
            "companyNo"=>$cgdinfo['companyNo'],
            "send_status"=>3,
            "send_num"=>$outinfo['good_num'],
            "wsend_num"=>0,
            "remark"=>$cgdinfo['remark'],
            "status"=>3,
            "lasttime"=>$cgdinfo['lasttime'],
            "is_del"=>0,
            "order_type"=>$outinfo['order_type'],
            "order_source"=>$outinfo['order_source'],
            "good_type"=>$cgdinfo['good_type'],
            "addtime"=>date("Y-m-d H:i:s"),
            "updatetime"=>date("Y-m-d H:i:s"),
            'good_createrid' => $good['createrid'],
            'good_creater' => $good['creater'],//商品创建人
        ];
        $insetrCgd=Db::name("purchease_order")->insert($QrdCgd);
        if($insetrCgd==false) throw new  Exception('新增采购单失败');
        else{
            $standing_book_da = array_merge($standing_book_da, [
                'orderCode' => $outinfo['orderCode'],
                'cgdNo' => $cgdinfo['cgdNo'],
                'spuCode' => $outinfo['spuCode'],
                'order_type' => $QrdCgd['order_type'],
                'order_source' => $QrdCgd['order_source'],
                'supplierNo' => $cgdinfo['supplierNo'],
                'companyNo' => $cgdinfo['companyNo'],
                'bk_code' => $cgdinfo['bkcode'],
                'purchease_id' => Db::name('purchease')->where('bk_code', $cgdinfo['bkcode'])->value('id',0),
            ]);
        }
        if($good['is_gold_price']==1 && $good['is_stock']==1){
            $gold = Db::name("gold_price1")
                ->field('id,price')
                ->where(["type" => $good['noble_metal'], "is_del" => 0, "status" => 1])
                ->order("addtime desc")
                ->find();

            $ct['cgd_gold_price']=$gold["price"];
            $updat=[
                "sale_price"=>0,
                "total_price"=>0,
                "origin_price"=>$cgdinfo['good_price'],
                "gold_price"=>$gold["price"],
            ];
            Db::name("sale")->where(["orderCode"=>$outinfo['orderCode']])->update($updat);
//            if($upsale==false){
//                return false;
//            }
        }
        $merge_num = Db::name("purchease_order")
            ->where(["bkcode"=>$cgdinfo['bkcode'],"order_type"=>1,"is_del"=>0])
            ->where("order_source","<>",0)
            ->field("sum(send_num)-sum(th_num) as num")
            ->find();
        $cgd['balance_num']=$cgd['total_num']-$merge_num['num'];
        $cgd['merge_num']=$merge_num['num'];
        $cgd['updatetime']=date("Y-m-d H:i:s");
        $up=Db::name("order_bk")->save($cgd);
        if($up==false) throw new  Exception('修改备库单失败');

        $data=[
            "orderCode"=>$outinfo['orderCode'],
            "cgdNo"=>$QrdCgd['cgdNo'],
            "spuCode"=>$outinfo['spuCode'],
            "companyNo"=>$outinfo['companyNo'],
            "good_num"=>$outinfo['good_num'],
            "wsend_num"=>$outinfo['good_num'],
            "send_num"=>0,
            "wait_num"=>$outinfo['good_num'],
            "status"=>1,
            "source"=>1,
        ];
        $order =Db::name("order_num")->save($data);
        if($order==false) throw new  Exception('修改采购单销售单关联失败');
    }




}